import{s as Me,n as Qe,o as He}from"../chunks/scheduler.889ebb13.js";import{S as We,i as je,g as o,s as a,r as l,A as Re,h as r,f as n,c as s,j as _e,u as p,x as j,k as Pe,y as Ie,a as i,v as c,d as m,t as f,w as u}from"../chunks/index.ca18042b.js";import{Q as R}from"../chunks/Question.e3bbda25.js";import{H as I}from"../chunks/Heading.3daa581c.js";import{E as Ee}from"../chunks/EditOnGithub.2e95618d.js";function De(Ae){let h,z,E,N,g,S,x,be="Which of the following best describes an AI Agent?",F,$,O,U,B,d,G,y,ve="Why does an Agent need to plan before taking an action?",J,w,K,V,X,A,Y,b,ke="Why are tools essential for an Agent?",Z,v,ee,te,ne,k,ie,L,Le="What is the key difference between Actions and Tools?",ae,T,se,oe,re,C,le,q,Te="How do LLMs contribute to an Agent’s functionality?",pe,_,ce,me,fe,P,ue,M,Ce="Which real-world example best illustrates an AI Agent at work?",he,Q,ge,xe,$e,H,qe="Congrats on finishing this Quiz 🥳! If you need to review any elements, take the time to revisit the chapter to reinforce your knowledge before diving deeper into the “Agent’s brain”: LLMs.",de,W,ye,D,we;return g=new I({props:{title:"Q1: What is an Agent?",local:"q1-what-is-an-agent",headingTag:"h3"}}),$=new R({props:{choices:[{text:"An AI model that can reason, plan, and use tools to interact with its environment to achieve a specific goal.",explain:"This definition captures the essential characteristics of an Agent.",correct:!0},{text:"A system that solely processes static text, without any inherent mechanism to interact dynamically with its surroundings or execute meaningful actions.",explain:"An Agent must be able to take an action and interact with its environment."},{text:"A conversational agent restricted to answering queries, lacking the ability to perform any actions or interact with external systems.",explain:"A chatbot like this lacks the ability to take actions, making it different from an Agent."},{text:"An online repository of information that offers static content without the capability to execute tasks or interact actively with users.",explain:"An Agent actively interacts with its environment rather than just providing static information."}]}}),d=new I({props:{title:"Q2: What is the Role of Planning in an Agent?",local:"q2-what-is-the-role-of-planning-in-an-agent",headingTag:"h3"}}),w=new R({props:{choices:[{text:"To primarily store or recall past interactions, rather than mapping out a sequence of future actions.",explain:"Planning is about determining future actions, not storing past interactions."},{text:"To decide on the sequence of actions and select appropriate tools needed to fulfill the user’s request.",explain:"Planning helps the Agent determine the best steps and tools to complete a task.",correct:!0},{text:"To execute a sequence of arbitrary and uncoordinated actions that lack any defined strategy or intentional objective.",explain:"Planning ensures the Agent's actions are intentional and not random."},{text:"To merely convert or translate text, bypassing any process of formulating a deliberate sequence of actions or employing strategic reasoning.",explain:"Planning is about structuring actions, not just converting text."}]}}),A=new I({props:{title:"Q3: How Do Tools Enhance an Agent’s Capabilities?",local:"q3-how-do-tools-enhance-an-agents-capabilities",headingTag:"h3"}}),v=new R({props:{choices:[{text:"Tools serve no real purpose and do not contribute to the Agent’s ability to perform actions beyond basic text generation.",explain:"Tools expand an Agent's capabilities by allowing it to perform actions beyond text generation."},{text:"Tools are solely designed for memory storage, lacking any capacity to facilitate the execution of tasks or enhance interactive performance.",explain:"Tools are primarily for performing actions, not just for storing data."},{text:"Tools severely restrict the Agent exclusively to generating text, thereby preventing it from engaging in a broader range of interactive actions.",explain:"On the contrary, tools allow Agents to go beyond text-based responses."},{text:"Tools provide the Agent with the ability to execute actions a text-generation model cannot perform natively, such as making coffee or generating images.",explain:"Tools enable Agents to interact with the real world and complete tasks.",correct:!0}]}}),k=new I({props:{title:"Q4: How Do Actions Differ from Tools?",local:"q4-how-do-actions-differ-from-tools",headingTag:"h3"}}),T=new R({props:{choices:[{text:"Actions are the steps the Agent takes, while Tools are external resources the Agent can use to perform those actions.",explain:"Actions are higher-level objectives, while Tools are specific functions the Agent can call upon.",correct:!0},{text:"Actions and Tools are entirely identical components that can be used interchangeably, with no clear differences between them.",explain:"No, Actions are goals or tasks, while Tools are specific utilities the Agent uses to achieve them."},{text:"Tools are considered broad utilities available for various functions, whereas Actions are mistakenly thought to be restricted only to physical interactions.",explain:"Not necessarily. Actions can involve both digital and physical tasks."},{text:"Actions inherently require the use of LLMs to be determined and executed, whereas Tools are designed to function autonomously without such dependencies.",explain:"While LLMs help decide Actions, Actions themselves are not dependent on LLMs."}]}}),C=new I({props:{title:"Q5: What Role Do Large Language Models (LLMs) Play in Agents?",local:"q5-what-role-do-large-language-models-llms-play-in-agents",headingTag:"h3"}}),_=new R({props:{choices:[{text:"LLMs function merely as passive repositories that store information, lacking any capability to actively process input or produce dynamic responses.",explain:"LLMs actively process text input and generate responses, rather than just storing information."},{text:"LLMs serve as the reasoning 'brain' of the Agent, processing text inputs to understand instructions and plan actions.",explain:"LLMs enable the Agent to interpret, plan, and decide on the next steps.",correct:!0},{text:"LLMs are erroneously believed to be used solely for image processing, when in fact their primary function is to process and generate text.",explain:"LLMs primarily work with text, although they can sometimes interact with multimodal inputs."},{text:"LLMs are considered completely irrelevant to the operation of AI Agents, implying that they are entirely superfluous in any practical application.",explain:"LLMs are a core component of modern AI Agents."}]}}),P=new I({props:{title:"Q6: Which of the Following Best Demonstrates an AI Agent?",local:"q6-which-of-the-following-best-demonstrates-an-ai-agent",headingTag:"h3"}}),Q=new R({props:{choices:[{text:"A static FAQ page on a website that provides fixed information and lacks any interactive or dynamic response capabilities.",explain:"A static FAQ page does not interact dynamically with users or take actions."},{text:"A simple calculator that performs arithmetic operations based on fixed rules, without any capability for reasoning or planning.",explain:"A calculator follows fixed rules without reasoning or planning, so it is not an Agent."},{text:"A virtual assistant like Siri or Alexa that can understand spoken commands, reason through them, and perform tasks like setting reminders or sending messages.",explain:"This example includes reasoning, planning, and interaction with the environment.",correct:!0},{text:"A video game NPC that operates on a fixed script of responses, without the ability to reason, plan, or use external tools.",explain:"Unless the NPC can reason, plan, and use tools, it does not function as an AI Agent."}]}}),W=new Ee({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/unit1/quiz1.mdx"}}),{c(){h=o("meta"),z=a(),E=o("p"),N=a(),l(g.$$.fragment),S=a(),x=o("p"),x.textContent=be,F=a(),l($.$$.fragment),O=a(),U=o("hr"),B=a(),l(d.$$.fragment),G=a(),y=o("p"),y.textContent=ve,J=a(),l(w.$$.fragment),K=a(),V=o("hr"),X=a(),l(A.$$.fragment),Y=a(),b=o("p"),b.textContent=ke,Z=a(),l(v.$$.fragment),ee=a(),te=o("hr"),ne=a(),l(k.$$.fragment),ie=a(),L=o("p"),L.textContent=Le,ae=a(),l(T.$$.fragment),se=a(),oe=o("hr"),re=a(),l(C.$$.fragment),le=a(),q=o("p"),q.textContent=Te,pe=a(),l(_.$$.fragment),ce=a(),me=o("hr"),fe=a(),l(P.$$.fragment),ue=a(),M=o("p"),M.textContent=Ce,he=a(),l(Q.$$.fragment),ge=a(),xe=o("hr"),$e=a(),H=o("p"),H.textContent=qe,de=a(),l(W.$$.fragment),ye=a(),D=o("p"),this.h()},l(e){const t=Re("svelte-u9bgzb",document.head);h=r(t,"META",{name:!0,content:!0}),t.forEach(n),z=s(e),E=r(e,"P",{}),_e(E).forEach(n),N=s(e),p(g.$$.fragment,e),S=s(e),x=r(e,"P",{"data-svelte-h":!0}),j(x)!=="svelte-1hxwi4j"&&(x.textContent=be),F=s(e),p($.$$.fragment,e),O=s(e),U=r(e,"HR",{}),B=s(e),p(d.$$.fragment,e),G=s(e),y=r(e,"P",{"data-svelte-h":!0}),j(y)!=="svelte-1eozxc0"&&(y.textContent=ve),J=s(e),p(w.$$.fragment,e),K=s(e),V=r(e,"HR",{}),X=s(e),p(A.$$.fragment,e),Y=s(e),b=r(e,"P",{"data-svelte-h":!0}),j(b)!=="svelte-nv9rej"&&(b.textContent=ke),Z=s(e),p(v.$$.fragment,e),ee=s(e),te=r(e,"HR",{}),ne=s(e),p(k.$$.fragment,e),ie=s(e),L=r(e,"P",{"data-svelte-h":!0}),j(L)!=="svelte-2s725x"&&(L.textContent=Le),ae=s(e),p(T.$$.fragment,e),se=s(e),oe=r(e,"HR",{}),re=s(e),p(C.$$.fragment,e),le=s(e),q=r(e,"P",{"data-svelte-h":!0}),j(q)!=="svelte-b9qx0n"&&(q.textContent=Te),pe=s(e),p(_.$$.fragment,e),ce=s(e),me=r(e,"HR",{}),fe=s(e),p(P.$$.fragment,e),ue=s(e),M=r(e,"P",{"data-svelte-h":!0}),j(M)!=="svelte-1wo13wl"&&(M.textContent=Ce),he=s(e),p(Q.$$.fragment,e),ge=s(e),xe=r(e,"HR",{}),$e=s(e),H=r(e,"P",{"data-svelte-h":!0}),j(H)!=="svelte-8rnr29"&&(H.textContent=qe),de=s(e),p(W.$$.fragment,e),ye=s(e),D=r(e,"P",{}),_e(D).forEach(n),this.h()},h(){Pe(h,"name","hf:doc:metadata"),Pe(h,"content",ze)},m(e,t){Ie(document.head,h),i(e,z,t),i(e,E,t),i(e,N,t),c(g,e,t),i(e,S,t),i(e,x,t),i(e,F,t),c($,e,t),i(e,O,t),i(e,U,t),i(e,B,t),c(d,e,t),i(e,G,t),i(e,y,t),i(e,J,t),c(w,e,t),i(e,K,t),i(e,V,t),i(e,X,t),c(A,e,t),i(e,Y,t),i(e,b,t),i(e,Z,t),c(v,e,t),i(e,ee,t),i(e,te,t),i(e,ne,t),c(k,e,t),i(e,ie,t),i(e,L,t),i(e,ae,t),c(T,e,t),i(e,se,t),i(e,oe,t),i(e,re,t),c(C,e,t),i(e,le,t),i(e,q,t),i(e,pe,t),c(_,e,t),i(e,ce,t),i(e,me,t),i(e,fe,t),c(P,e,t),i(e,ue,t),i(e,M,t),i(e,he,t),c(Q,e,t),i(e,ge,t),i(e,xe,t),i(e,$e,t),i(e,H,t),i(e,de,t),c(W,e,t),i(e,ye,t),i(e,D,t),we=!0},p:Qe,i(e){we||(m(g.$$.fragment,e),m($.$$.fragment,e),m(d.$$.fragment,e),m(w.$$.fragment,e),m(A.$$.fragment,e),m(v.$$.fragment,e),m(k.$$.fragment,e),m(T.$$.fragment,e),m(C.$$.fragment,e),m(_.$$.fragment,e),m(P.$$.fragment,e),m(Q.$$.fragment,e),m(W.$$.fragment,e),we=!0)},o(e){f(g.$$.fragment,e),f($.$$.fragment,e),f(d.$$.fragment,e),f(w.$$.fragment,e),f(A.$$.fragment,e),f(v.$$.fragment,e),f(k.$$.fragment,e),f(T.$$.fragment,e),f(C.$$.fragment,e),f(_.$$.fragment,e),f(P.$$.fragment,e),f(Q.$$.fragment,e),f(W.$$.fragment,e),we=!1},d(e){e&&(n(z),n(E),n(N),n(S),n(x),n(F),n(O),n(U),n(B),n(G),n(y),n(J),n(K),n(V),n(X),n(Y),n(b),n(Z),n(ee),n(te),n(ne),n(ie),n(L),n(ae),n(se),n(oe),n(re),n(le),n(q),n(pe),n(ce),n(me),n(fe),n(ue),n(M),n(he),n(ge),n(xe),n($e),n(H),n(de),n(ye),n(D)),n(h),u(g,e),u($,e),u(d,e),u(w,e),u(A,e),u(v,e),u(k,e),u(T,e),u(C,e),u(_,e),u(P,e),u(Q,e),u(W,e)}}}const ze='{"title":"Q1: What is an Agent?","local":"q1-what-is-an-agent","sections":[],"depth":3}';function Ne(Ae){return He(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ge extends We{constructor(h){super(),je(this,h,Ne,De,Me,{})}}export{Ge as component};
