import{s as On,f as ke,o as Xn}from"../chunks/scheduler.889ebb13.js";import{S as Fn,i as Rn,g as a,s as l,r as u,A as Sn,h as o,f as n,c as i,j as Nn,u as f,x as r,k as p,y as Yn,a as s,v as g,d as h,t as c,w as v,m as Kn,n as Qn}from"../chunks/index.ca18042b.js";import{T as Dn}from"../chunks/Tip.b8116e3c.js";import{C as Zn}from"../chunks/CodeBlock.1db71023.js";import{H as T}from"../chunks/Heading.3daa581c.js";import{E as es}from"../chunks/EditOnGithub.2e95618d.js";function ts(Ie){let m;return{c(){m=Kn("It's also possible to use models that accept other inputs as the Agent's core model. For example, a Vision Language Model (VLM), which is like an LLM but also understands images as input. We'll focus on LLMs for now and will discuss other options later.")},l(d){m=Qn(d,"It's also possible to use models that accept other inputs as the Agent's core model. For example, a Vision Language Model (VLM), which is like an LLM but also understands images as input. We'll focus on LLMs for now and will discuss other options later.")},m(d,$){s(d,m,$)},d(d){d&&n(m)}}}function ns(Ie){let m,d,$,Pe,M,qe,L,Ot,je,C,Xt="By the end of this section, you’ll feel comfortable with the concept of agents and their various applications in AI.",Be,y,Ft="To explain what an Agent is, let’s start with an analogy.",Je,b,Ge,_,Rt="Meet Alfred. Alfred is an <strong>Agent</strong>.",We,A,St,ze,k,Yt="Imagine Alfred <strong>receives a command</strong>, such as: “Alfred, I would like a coffee please.”",Ee,H,Kt,Ue,I,Qt="Because Alfred <strong>understands natural language</strong>, he quickly grasps our request.",Ve,P,Dt="Before fulfilling the order, Alfred engages in <strong>reasoning and planning</strong>, figuring out the steps and tools he needs to:",Ne,q,en="<li>Go to the kitchen</li> <li>Use the coffee machine</li> <li>Brew the coffee</li> <li>Bring the coffee back</li>",Ze,j,tn,Oe,B,nn="Once he has a plan, he <strong>must act</strong>. To execute his plan, <strong>he can use tools from the list of tools he knows about</strong>.",Xe,J,sn="In this case, to make a coffee, he uses a coffee machine. He activates the coffee machine to brew the coffee.",Fe,G,ln,Re,W,an="Finally, Alfred brings the freshly brewed coffee to us.",Se,z,on,Ye,E,rn="And this is what an Agent is: an <strong>AI model capable of reasoning, planning, and interacting with its environment</strong>.",Ke,U,pn="We call it Agent because it has <em>agency</em>, aka it has the ability to interact with the environment.",Qe,V,mn,De,N,et,Z,un="Now that you have the big picture, here’s a more precise definition:",tt,O,fn="<p>An Agent is a system that leverages an AI model to interact with its environment in order to achieve a user-defined objective. It combines reasoning, planning, and the execution of actions (often via external tools) to fulfill tasks.</p>",nt,X,gn="Think of the Agent as having two main parts:",st,F,hn="<li><strong>The Brain (AI Model)</strong></li>",lt,R,cn=`This is where all the thinking happens. The AI model <strong>handles reasoning and planning</strong>.
It decides <strong>which Actions to take based on the situation</strong>.`,it,w,vn="<li><strong>The Body (Capabilities and Tools)</strong></li>",at,S,dn="This part represents <strong>everything the Agent is equipped to do</strong>.",ot,Y,Tn="The <strong>scope of possible actions</strong> depends on what the agent <strong>has been equipped with</strong>. For example, because humans lack wings, they can’t perform the “fly” <strong>Action</strong>, but they can execute <strong>Actions</strong> like “walk”, “run” ,“jump”, “grab”, and so on.",rt,K,pt,Q,wn="The most common AI model found in Agents is an LLM (Large Language Model), which  takes <strong>Text</strong> as an input and outputs <strong>Text</strong> as well.",mt,D,xn='Well known examples are <strong>GPT4</strong> from <strong>OpenAI</strong>, <strong>LLama</strong> from <strong>Meta</strong>, <strong>Gemini</strong> from <strong>Google</strong>, etc. These models have been trained on a vast amount of text and are able to generalize well. We will learn more about LLMs in the <a href="what-are-llms.mdx">next section</a>.',ut,x,ft,ee,gt,te,$n="LLMs are amazing models, but <strong>they can only generate text</strong>.",ht,ne,Mn="However, if you ask a well-known chat application like HuggingChat or ChatGPT to generate an image, they can! How is that possible?",ct,se,Ln="The answer is that the developers of HuggingChat, ChatGPT and similar apps implemented additional functionality (called <strong>Tools</strong>), that the LLM can use to create images.",vt,le,Cn='<img src="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/eiffel_brocolis.jpg" alt="Eiffel Brocolis"/> <figcaption>The model used an Image Generation Tool to generate this image.</figcaption>',dt,ie,yn='We will learn more about tools in the <a href="tools.mdx">Tools</a> section.',Tt,ae,wt,oe,bn="An Agent can perform any task we implement via <strong>Tools</strong> to complete <strong>Actions</strong>.",xt,re,_n="For example, if I write an Agent to act as my personal assistant (like Siri) on my computer, and I ask it to “send an email to my Manager asking to delay today’s meeting”, I can give it some code to send emails. This will be a new Tool the Agent can use whenever it needs to send an email. We can write it in Python:",$t,pe,Mt,me,An="The LLM, as we’ll see, will generate code to run the tool when it needs to, and thus fulfill the desired task.",Lt,ue,Ct,fe,kn="The <strong>design of the Tools is very important and has a great impact on the quality of your Agent</strong>. Some tasks will require very specific Tools to be crafted, while others may be solved with general purpose tools like “web_search”.",yt,ge,Hn="<p>Note that <strong>Actions are not the same as Tools</strong>. An Action, for instance, can involve the use of multiple Tools to complete.</p>",bt,he,In="Allowing an agent to interact with its environment <strong>allows real-life usage for companies and individuals</strong>.",_t,ce,At,ve,Pn="Virtual assistants like Siri, Alexa, or Google Assistant, work as agents when they interact on behalf of users using their digital environments.",kt,de,qn="They take user queries, analyze context, retrieve information from databases, and provide responses or initiate actions (like setting reminders, sending messages, or controlling smart devices).",Ht,Te,It,we,jn="Many companies deploy chatbots as agents that interact with customers in natural language.",Pt,xe,Bn="These agents can answer questions, guide users through troubleshooting steps, open issues in internal databases, or even complete transactions.",qt,$e,Jn="Their predefined objectives might include improving user satisfaction, reducing wait times, or increasing sales conversion rates. By interacting directly with customers, learning from the dialogues, and adapting their responses over time, they demonstrate the core principles of an agent in action.",jt,Me,Bt,Le,Gn="AI agents powered by LLMs can make Non-Playable Characters (NPCs) more dynamic and unpredictable.",Jt,Ce,Wn="Instead of following rigid behavior trees, they can <strong>respond contextually, adapt to player interactions</strong>, and generate more nuanced dialogue. This flexibility helps create more lifelike, engaging characters that evolve alongside the player’s actions.",Gt,Wt,zt,ye,zn="To summarize, an Agent is a system that uses an AI Model (typically an LLM) as its core reasoning engine, to:",Et,be,En="<li><p><strong>Understand natural language:</strong>  Interpret and respond to human instructions in a meaningful way.</p></li> <li><p><strong>Reason and plan:</strong> Analyze information, make decisions, and devise strategies to solve problems.</p></li> <li><p><strong>Interact with its environment:</strong> Gather information, take actions, and observe the results of those actions.</p></li>",Ut,_e,Un='Now that you have a solid grasp of what Agents are, let’s reinforce your understanding with a short, ungraded quiz. After that, we’ll dive into the “Agent’s brain”: the <a href="what-are-llms.mdx">LLMs</a>.',Vt,Ae,Nt,He,Zt;return M=new T({props:{title:"What is an Agent?",local:"what-is-an-agent",headingTag:"h1"}}),b=new T({props:{title:"The Big Picture: Alfred The Agent",local:"the-big-picture-alfred-the-agent",headingTag:"h2"}}),N=new T({props:{title:"Let’s go more formal",local:"lets-go-more-formal",headingTag:"h2"}}),K=new T({props:{title:"What type of AI Models do we use for Agents?",local:"what-type-of-ai-models-do-we-use-for-agents",headingTag:"h2"}}),x=new Dn({props:{$$slots:{default:[ts]},$$scope:{ctx:Ie}}}),ee=new T({props:{title:"How does an AI take action on its environment?",local:"how-does-an-ai-take-action-on-its-environment",headingTag:"h2"}}),ae=new T({props:{title:"What type of tasks can an Agent do?",local:"what-type-of-tasks-can-an-agent-do",headingTag:"h2"}}),pe=new Zn({props:{code:"ZGVmJTIwc2VuZF9tZXNzYWdlX3RvKHJlY2lwaWVudCUyQyUyMG1lc3NhZ2UpJTNBJTBBJTIwJTIwJTIwJTIwJTIyJTIyJTIyVXNlZnVsJTIwdG8lMjBzZW5kJTIwYW4lMjBlLW1haWwlMjBtZXNzYWdlJTIwdG8lMjBhJTIwcmVjaXBpZW50JTIyJTIyJTIyJTBBJTIwJTIwJTIwJTIwLi4u",highlighted:`<span class="hljs-keyword">def</span> <span class="hljs-title function_">send_message_to</span>(<span class="hljs-params">recipient, message</span>):
    <span class="hljs-string">&quot;&quot;&quot;Useful to send an e-mail message to a recipient&quot;&quot;&quot;</span>
    ...`,wrap:!1}}),ue=new Zn({props:{code:"c2VuZF9tZXNzYWdlX3RvKCUyMk1hbmFnZXIlMjIlMkMlMjAlMjJDYW4lMjB3ZSUyMHBvc3Rwb25lJTIwdG9kYXkncyUyMG1lZXRpbmclM0YlMjIp",highlighted:'send_message_to(<span class="hljs-string">&quot;Manager&quot;</span>, <span class="hljs-string">&quot;Can we postpone today&#x27;s meeting?&quot;</span>)',wrap:!1}}),ce=new T({props:{title:"Example 1: Personal Virtual Assistants",local:"example-1-personal-virtual-assistants",headingTag:"h3"}}),Te=new T({props:{title:"Example 2: Customer Service Chatbots",local:"example-2-customer-service-chatbots",headingTag:"h3"}}),Me=new T({props:{title:"Example 3: AI Non-Playable Character in a video game",local:"example-3-ai-non-playable-character-in-a-video-game",headingTag:"h3"}}),Ae=new es({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/unit1/what-are-agents.mdx"}}),{c(){m=a("meta"),d=l(),$=a("p"),Pe=l(),u(M.$$.fragment),qe=l(),L=a("img"),je=l(),C=a("p"),C.textContent=Xt,Be=l(),y=a("p"),y.textContent=Ft,Je=l(),u(b.$$.fragment),Ge=l(),_=a("p"),_.innerHTML=Rt,We=l(),A=a("img"),ze=l(),k=a("p"),k.innerHTML=Yt,Ee=l(),H=a("img"),Ue=l(),I=a("p"),I.innerHTML=Qt,Ve=l(),P=a("p"),P.innerHTML=Dt,Ne=l(),q=a("ol"),q.innerHTML=en,Ze=l(),j=a("img"),Oe=l(),B=a("p"),B.innerHTML=nn,Xe=l(),J=a("p"),J.textContent=sn,Fe=l(),G=a("img"),Re=l(),W=a("p"),W.textContent=an,Se=l(),z=a("img"),Ye=l(),E=a("p"),E.innerHTML=rn,Ke=l(),U=a("p"),U.innerHTML=pn,Qe=l(),V=a("img"),De=l(),u(N.$$.fragment),et=l(),Z=a("p"),Z.textContent=un,tt=l(),O=a("blockquote"),O.innerHTML=fn,nt=l(),X=a("p"),X.textContent=gn,st=l(),F=a("ol"),F.innerHTML=hn,lt=l(),R=a("p"),R.innerHTML=cn,it=l(),w=a("ol"),w.innerHTML=vn,at=l(),S=a("p"),S.innerHTML=dn,ot=l(),Y=a("p"),Y.innerHTML=Tn,rt=l(),u(K.$$.fragment),pt=l(),Q=a("p"),Q.innerHTML=wn,mt=l(),D=a("p"),D.innerHTML=xn,ut=l(),u(x.$$.fragment),ft=l(),u(ee.$$.fragment),gt=l(),te=a("p"),te.innerHTML=$n,ht=l(),ne=a("p"),ne.textContent=Mn,ct=l(),se=a("p"),se.innerHTML=Ln,vt=l(),le=a("figure"),le.innerHTML=Cn,dt=l(),ie=a("p"),ie.innerHTML=yn,Tt=l(),u(ae.$$.fragment),wt=l(),oe=a("p"),oe.innerHTML=bn,xt=l(),re=a("p"),re.textContent=_n,$t=l(),u(pe.$$.fragment),Mt=l(),me=a("p"),me.textContent=An,Lt=l(),u(ue.$$.fragment),Ct=l(),fe=a("p"),fe.innerHTML=kn,yt=l(),ge=a("blockquote"),ge.innerHTML=Hn,bt=l(),he=a("p"),he.innerHTML=In,_t=l(),u(ce.$$.fragment),At=l(),ve=a("p"),ve.textContent=Pn,kt=l(),de=a("p"),de.textContent=qn,Ht=l(),u(Te.$$.fragment),It=l(),we=a("p"),we.textContent=jn,Pt=l(),xe=a("p"),xe.textContent=Bn,qt=l(),$e=a("p"),$e.textContent=Jn,jt=l(),u(Me.$$.fragment),Bt=l(),Le=a("p"),Le.textContent=Gn,Jt=l(),Ce=a("p"),Ce.innerHTML=Wn,Gt=l(),Wt=a("hr"),zt=l(),ye=a("p"),ye.textContent=zn,Et=l(),be=a("ul"),be.innerHTML=En,Ut=l(),_e=a("p"),_e.innerHTML=Un,Vt=l(),u(Ae.$$.fragment),Nt=l(),He=a("p"),this.h()},l(e){const t=Sn("svelte-u9bgzb",document.head);m=o(t,"META",{name:!0,content:!0}),t.forEach(n),d=i(e),$=o(e,"P",{}),Nn($).forEach(n),Pe=i(e),f(M.$$.fragment,e),qe=i(e),L=o(e,"IMG",{src:!0,alt:!0}),je=i(e),C=o(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-1siq37n"&&(C.textContent=Xt),Be=i(e),y=o(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-1211ay7"&&(y.textContent=Ft),Je=i(e),f(b.$$.fragment,e),Ge=i(e),_=o(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-1b93926"&&(_.innerHTML=Rt),We=i(e),A=o(e,"IMG",{src:!0,alt:!0}),ze=i(e),k=o(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-2lcquf"&&(k.innerHTML=Yt),Ee=i(e),H=o(e,"IMG",{src:!0,alt:!0}),Ue=i(e),I=o(e,"P",{"data-svelte-h":!0}),r(I)!=="svelte-1vfpoib"&&(I.innerHTML=Qt),Ve=i(e),P=o(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-129qhbs"&&(P.innerHTML=Dt),Ne=i(e),q=o(e,"OL",{"data-svelte-h":!0}),r(q)!=="svelte-1qza0to"&&(q.innerHTML=en),Ze=i(e),j=o(e,"IMG",{src:!0,alt:!0}),Oe=i(e),B=o(e,"P",{"data-svelte-h":!0}),r(B)!=="svelte-106u9jb"&&(B.innerHTML=nn),Xe=i(e),J=o(e,"P",{"data-svelte-h":!0}),r(J)!=="svelte-emguw1"&&(J.textContent=sn),Fe=i(e),G=o(e,"IMG",{src:!0,alt:!0}),Re=i(e),W=o(e,"P",{"data-svelte-h":!0}),r(W)!=="svelte-7vbcn2"&&(W.textContent=an),Se=i(e),z=o(e,"IMG",{src:!0,alt:!0}),Ye=i(e),E=o(e,"P",{"data-svelte-h":!0}),r(E)!=="svelte-oqpk4a"&&(E.innerHTML=rn),Ke=i(e),U=o(e,"P",{"data-svelte-h":!0}),r(U)!=="svelte-wcohvf"&&(U.innerHTML=pn),Qe=i(e),V=o(e,"IMG",{src:!0,alt:!0}),De=i(e),f(N.$$.fragment,e),et=i(e),Z=o(e,"P",{"data-svelte-h":!0}),r(Z)!=="svelte-1xioahh"&&(Z.textContent=un),tt=i(e),O=o(e,"BLOCKQUOTE",{"data-svelte-h":!0}),r(O)!=="svelte-bqnsze"&&(O.innerHTML=fn),nt=i(e),X=o(e,"P",{"data-svelte-h":!0}),r(X)!=="svelte-1vjdhid"&&(X.textContent=gn),st=i(e),F=o(e,"OL",{"data-svelte-h":!0}),r(F)!=="svelte-n47p7t"&&(F.innerHTML=hn),lt=i(e),R=o(e,"P",{"data-svelte-h":!0}),r(R)!=="svelte-o8yrnk"&&(R.innerHTML=cn),it=i(e),w=o(e,"OL",{start:!0,"data-svelte-h":!0}),r(w)!=="svelte-1htz1vb"&&(w.innerHTML=vn),at=i(e),S=o(e,"P",{"data-svelte-h":!0}),r(S)!=="svelte-1bgle5v"&&(S.innerHTML=dn),ot=i(e),Y=o(e,"P",{"data-svelte-h":!0}),r(Y)!=="svelte-1h7cnvq"&&(Y.innerHTML=Tn),rt=i(e),f(K.$$.fragment,e),pt=i(e),Q=o(e,"P",{"data-svelte-h":!0}),r(Q)!=="svelte-ereclb"&&(Q.innerHTML=wn),mt=i(e),D=o(e,"P",{"data-svelte-h":!0}),r(D)!=="svelte-s16y55"&&(D.innerHTML=xn),ut=i(e),f(x.$$.fragment,e),ft=i(e),f(ee.$$.fragment,e),gt=i(e),te=o(e,"P",{"data-svelte-h":!0}),r(te)!=="svelte-1icipy1"&&(te.innerHTML=$n),ht=i(e),ne=o(e,"P",{"data-svelte-h":!0}),r(ne)!=="svelte-fhzf0g"&&(ne.textContent=Mn),ct=i(e),se=o(e,"P",{"data-svelte-h":!0}),r(se)!=="svelte-nq3vk2"&&(se.innerHTML=Ln),vt=i(e),le=o(e,"FIGURE",{"data-svelte-h":!0}),r(le)!=="svelte-lgjug2"&&(le.innerHTML=Cn),dt=i(e),ie=o(e,"P",{"data-svelte-h":!0}),r(ie)!=="svelte-11o9cku"&&(ie.innerHTML=yn),Tt=i(e),f(ae.$$.fragment,e),wt=i(e),oe=o(e,"P",{"data-svelte-h":!0}),r(oe)!=="svelte-84d0a1"&&(oe.innerHTML=bn),xt=i(e),re=o(e,"P",{"data-svelte-h":!0}),r(re)!=="svelte-1ffg8zo"&&(re.textContent=_n),$t=i(e),f(pe.$$.fragment,e),Mt=i(e),me=o(e,"P",{"data-svelte-h":!0}),r(me)!=="svelte-1d3qiev"&&(me.textContent=An),Lt=i(e),f(ue.$$.fragment,e),Ct=i(e),fe=o(e,"P",{"data-svelte-h":!0}),r(fe)!=="svelte-zj080m"&&(fe.innerHTML=kn),yt=i(e),ge=o(e,"BLOCKQUOTE",{"data-svelte-h":!0}),r(ge)!=="svelte-c2to7d"&&(ge.innerHTML=Hn),bt=i(e),he=o(e,"P",{"data-svelte-h":!0}),r(he)!=="svelte-h24vmr"&&(he.innerHTML=In),_t=i(e),f(ce.$$.fragment,e),At=i(e),ve=o(e,"P",{"data-svelte-h":!0}),r(ve)!=="svelte-1nwemo6"&&(ve.textContent=Pn),kt=i(e),de=o(e,"P",{"data-svelte-h":!0}),r(de)!=="svelte-4zesrr"&&(de.textContent=qn),Ht=i(e),f(Te.$$.fragment,e),It=i(e),we=o(e,"P",{"data-svelte-h":!0}),r(we)!=="svelte-uapked"&&(we.textContent=jn),Pt=i(e),xe=o(e,"P",{"data-svelte-h":!0}),r(xe)!=="svelte-14i5qzp"&&(xe.textContent=Bn),qt=i(e),$e=o(e,"P",{"data-svelte-h":!0}),r($e)!=="svelte-19f1pt9"&&($e.textContent=Jn),jt=i(e),f(Me.$$.fragment,e),Bt=i(e),Le=o(e,"P",{"data-svelte-h":!0}),r(Le)!=="svelte-ivp725"&&(Le.textContent=Gn),Jt=i(e),Ce=o(e,"P",{"data-svelte-h":!0}),r(Ce)!=="svelte-143bvek"&&(Ce.innerHTML=Wn),Gt=i(e),Wt=o(e,"HR",{}),zt=i(e),ye=o(e,"P",{"data-svelte-h":!0}),r(ye)!=="svelte-s74a2f"&&(ye.textContent=zn),Et=i(e),be=o(e,"UL",{"data-svelte-h":!0}),r(be)!=="svelte-15p5ox7"&&(be.innerHTML=En),Ut=i(e),_e=o(e,"P",{"data-svelte-h":!0}),r(_e)!=="svelte-1gqjjx9"&&(_e.innerHTML=Un),Vt=i(e),f(Ae.$$.fragment,e),Nt=i(e),He=o(e,"P",{}),Nn(He).forEach(n),this.h()},h(){p(m,"name","hf:doc:metadata"),p(m,"content",ss),ke(L.src,Ot="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/whiteboard-no-check.jpg")||p(L,"src",Ot),p(L,"alt","Unit 1 planning"),ke(A.src,St="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/this-is-alfred.jpg")||p(A,"src",St),p(A,"alt","This is Alfred"),ke(H.src,Kt="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/coffee-please.jpg")||p(H,"src",Kt),p(H,"alt","I would like a coffee"),ke(j.src,tn="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/reason-and-plan.jpg")||p(j,"src",tn),p(j,"alt","Reason and plan"),ke(G.src,ln="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/make-coffee.jpg")||p(G,"src",ln),p(G,"alt","Make coffee"),ke(z.src,on="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/bring-coffee.jpg")||p(z,"src",on),p(z,"alt","Bring coffee"),ke(V.src,mn="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/process.jpg")||p(V,"src",mn),p(V,"alt","Agent process"),p(w,"start","2")},m(e,t){Yn(document.head,m),s(e,d,t),s(e,$,t),s(e,Pe,t),g(M,e,t),s(e,qe,t),s(e,L,t),s(e,je,t),s(e,C,t),s(e,Be,t),s(e,y,t),s(e,Je,t),g(b,e,t),s(e,Ge,t),s(e,_,t),s(e,We,t),s(e,A,t),s(e,ze,t),s(e,k,t),s(e,Ee,t),s(e,H,t),s(e,Ue,t),s(e,I,t),s(e,Ve,t),s(e,P,t),s(e,Ne,t),s(e,q,t),s(e,Ze,t),s(e,j,t),s(e,Oe,t),s(e,B,t),s(e,Xe,t),s(e,J,t),s(e,Fe,t),s(e,G,t),s(e,Re,t),s(e,W,t),s(e,Se,t),s(e,z,t),s(e,Ye,t),s(e,E,t),s(e,Ke,t),s(e,U,t),s(e,Qe,t),s(e,V,t),s(e,De,t),g(N,e,t),s(e,et,t),s(e,Z,t),s(e,tt,t),s(e,O,t),s(e,nt,t),s(e,X,t),s(e,st,t),s(e,F,t),s(e,lt,t),s(e,R,t),s(e,it,t),s(e,w,t),s(e,at,t),s(e,S,t),s(e,ot,t),s(e,Y,t),s(e,rt,t),g(K,e,t),s(e,pt,t),s(e,Q,t),s(e,mt,t),s(e,D,t),s(e,ut,t),g(x,e,t),s(e,ft,t),g(ee,e,t),s(e,gt,t),s(e,te,t),s(e,ht,t),s(e,ne,t),s(e,ct,t),s(e,se,t),s(e,vt,t),s(e,le,t),s(e,dt,t),s(e,ie,t),s(e,Tt,t),g(ae,e,t),s(e,wt,t),s(e,oe,t),s(e,xt,t),s(e,re,t),s(e,$t,t),g(pe,e,t),s(e,Mt,t),s(e,me,t),s(e,Lt,t),g(ue,e,t),s(e,Ct,t),s(e,fe,t),s(e,yt,t),s(e,ge,t),s(e,bt,t),s(e,he,t),s(e,_t,t),g(ce,e,t),s(e,At,t),s(e,ve,t),s(e,kt,t),s(e,de,t),s(e,Ht,t),g(Te,e,t),s(e,It,t),s(e,we,t),s(e,Pt,t),s(e,xe,t),s(e,qt,t),s(e,$e,t),s(e,jt,t),g(Me,e,t),s(e,Bt,t),s(e,Le,t),s(e,Jt,t),s(e,Ce,t),s(e,Gt,t),s(e,Wt,t),s(e,zt,t),s(e,ye,t),s(e,Et,t),s(e,be,t),s(e,Ut,t),s(e,_e,t),s(e,Vt,t),g(Ae,e,t),s(e,Nt,t),s(e,He,t),Zt=!0},p(e,[t]){const Vn={};t&2&&(Vn.$$scope={dirty:t,ctx:e}),x.$set(Vn)},i(e){Zt||(h(M.$$.fragment,e),h(b.$$.fragment,e),h(N.$$.fragment,e),h(K.$$.fragment,e),h(x.$$.fragment,e),h(ee.$$.fragment,e),h(ae.$$.fragment,e),h(pe.$$.fragment,e),h(ue.$$.fragment,e),h(ce.$$.fragment,e),h(Te.$$.fragment,e),h(Me.$$.fragment,e),h(Ae.$$.fragment,e),Zt=!0)},o(e){c(M.$$.fragment,e),c(b.$$.fragment,e),c(N.$$.fragment,e),c(K.$$.fragment,e),c(x.$$.fragment,e),c(ee.$$.fragment,e),c(ae.$$.fragment,e),c(pe.$$.fragment,e),c(ue.$$.fragment,e),c(ce.$$.fragment,e),c(Te.$$.fragment,e),c(Me.$$.fragment,e),c(Ae.$$.fragment,e),Zt=!1},d(e){e&&(n(d),n($),n(Pe),n(qe),n(L),n(je),n(C),n(Be),n(y),n(Je),n(Ge),n(_),n(We),n(A),n(ze),n(k),n(Ee),n(H),n(Ue),n(I),n(Ve),n(P),n(Ne),n(q),n(Ze),n(j),n(Oe),n(B),n(Xe),n(J),n(Fe),n(G),n(Re),n(W),n(Se),n(z),n(Ye),n(E),n(Ke),n(U),n(Qe),n(V),n(De),n(et),n(Z),n(tt),n(O),n(nt),n(X),n(st),n(F),n(lt),n(R),n(it),n(w),n(at),n(S),n(ot),n(Y),n(rt),n(pt),n(Q),n(mt),n(D),n(ut),n(ft),n(gt),n(te),n(ht),n(ne),n(ct),n(se),n(vt),n(le),n(dt),n(ie),n(Tt),n(wt),n(oe),n(xt),n(re),n($t),n(Mt),n(me),n(Lt),n(Ct),n(fe),n(yt),n(ge),n(bt),n(he),n(_t),n(At),n(ve),n(kt),n(de),n(Ht),n(It),n(we),n(Pt),n(xe),n(qt),n($e),n(jt),n(Bt),n(Le),n(Jt),n(Ce),n(Gt),n(Wt),n(zt),n(ye),n(Et),n(be),n(Ut),n(_e),n(Vt),n(Nt),n(He)),n(m),v(M,e),v(b,e),v(N,e),v(K,e),v(x,e),v(ee,e),v(ae,e),v(pe,e),v(ue,e),v(ce,e),v(Te,e),v(Me,e),v(Ae,e)}}}const ss='{"title":"What is an Agent?","local":"what-is-an-agent","sections":[{"title":"The Big Picture: Alfred The Agent","local":"the-big-picture-alfred-the-agent","sections":[],"depth":2},{"title":"Let’s go more formal","local":"lets-go-more-formal","sections":[],"depth":2},{"title":"What type of AI Models do we use for Agents?","local":"what-type-of-ai-models-do-we-use-for-agents","sections":[],"depth":2},{"title":"How does an AI take action on its environment?","local":"how-does-an-ai-take-action-on-its-environment","sections":[],"depth":2},{"title":"What type of tasks can an Agent do?","local":"what-type-of-tasks-can-an-agent-do","sections":[{"title":"Example 1: Personal Virtual Assistants","local":"example-1-personal-virtual-assistants","sections":[],"depth":3},{"title":"Example 2: Customer Service Chatbots","local":"example-2-customer-service-chatbots","sections":[],"depth":3},{"title":"Example 3: AI Non-Playable Character in a video game","local":"example-3-ai-non-playable-character-in-a-video-game","sections":[],"depth":3}],"depth":2}],"depth":1}';function ls(Ie){return Xn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class us extends Fn{constructor(m){super(),Rn(this,m,ls,ns,On,{})}}export{us as component};
