import{s as Kn,f as Pe,o as Qn,n as Xn}from"../chunks/scheduler.889ebb13.js";import{S as Zn,i as ei,g as l,s,r as g,m as ti,A as ni,h as r,f as n,c as o,j as qe,u as c,x as a,n as ii,k as u,y as si,a as i,v,d as L,t as w,w as x}from"../chunks/index.ca18042b.js";import{T as oi}from"../chunks/Tip.b8116e3c.js";import{H as _}from"../chunks/Heading.3daa581c.js";import{E as li}from"../chunks/EditOnGithub.2e95618d.js";function ri(Ie){let p,y='We do not expect you to memorize these special tokens, but it is important to appreciate their diversity and the role they play in the text generation of LLMs. If you want to know more about special tokens, you can check out the configuration of the model in its Hub repository. For example, you can find the special tokens of the SmolLM2 model in its <a href="https://huggingface.co/HuggingFaceTB/SmolLM2-135M-Instruct/blob/main/tokenizer_config.json">tokenizer_config.json</a>.';return{c(){p=l("p"),p.innerHTML=y},l(h){p=r(h,"P",{"data-svelte-h":!0}),a(p)!=="svelte-1fk4atp"&&(p.innerHTML=y)},m(h,Ae){i(h,p,Ae)},p:Xn,d(h){h&&n(p)}}}function ai(Ie){let p,y,h,Ae,C,Fe,$,Vt,Se,H,Jt="In the previous section we learned that each Agent needs <strong>an AI Model at its core</strong>, and that LLMs are the most common type of AI models for this purpose.",ze,P,Kt="Now we will learn what LLMs are and how they power Agents.",Ge,A,Qt='This section offers a concise technical explanation of the use of LLMs. If you want to dive deeper, you can check our <a href="https://huggingface.co/learn/nlp-course/chapter1/1" target="_blank">free Natural Language Processing Course</a>.',Re,E,Ue,q,Xt="An LLM is a type of AI model that excels at <strong>understanding and generating human language</strong>. They are trained on vast amounts of text data, allowing them to learn patterns, structure, and even nuance in language. These models typically consist of many millions of parameters.",Be,I,Zt="Most LLMs nowadays are <strong>built on the Transformer architecture</strong>—a deep learning architecture based on the “Attention” algorithm, that has gained significant interest since the release of BERT from Google in 2018.",Oe,F,en='<img src="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/transformer.jpg" alt="Transformer"/> <figcaption>The original Transformer architecture looked like this, with an encoder on the left and a decoder on the right.</figcaption>',je,S,tn="There are 3 types of transformers:",We,z,nn=`<li><p><strong>Encoders</strong><br/>
An encoder-based Transformer takes text (or other data) as input and outputs a dense representation (or embedding) of that text.</p> <ul><li><strong>Example</strong>: BERT from Google</li> <li><strong>Use Cases</strong>: Text classification, semantic search, Named Entity Recognition</li> <li><strong>Typical Size</strong>: Millions of parameters</li></ul></li> <li><p><strong>Decoders</strong><br/>
A decoder-based Transformer focuses <strong>on generating new tokens to complete a sequence, one token at a time</strong>.</p> <ul><li><strong>Example</strong>: Llama from Meta</li> <li><strong>Use Cases</strong>: Text generation, chatbots, code generation</li> <li><strong>Typical Size</strong>: Billions (in the US sense, i.e., 10^9) of parameters</li></ul></li> <li><p><strong>Seq2Seq (Encoder–Decoder)</strong><br/>
A sequence-to-sequence Transformer <em>combines</em> an encoder and a decoder. The encoder first processes the input sequence into a context representation, then the decoder generates an output sequence.</p> <ul><li><strong>Example</strong>: T5, BART</li> <li><strong>Use Cases</strong>:  Translation, Summarization, Paraphrasing</li> <li><strong>Typical Size</strong>: Millions of parameters</li></ul></li>`,Ne,G,sn="Although Large Language Models come in various forms, LLMs are typically decoder-based models with billions of parameters. Here are some of the most well-known LLMs:",De,R,on="<thead><tr><th><strong>Model</strong></th> <th><strong>Provider</strong></th></tr></thead> <tbody><tr><td><strong>Deepseek-R1</strong></td> <td>DeepSeek</td></tr> <tr><td><strong>GPT4</strong></td> <td>OpenAI</td></tr> <tr><td><strong>Llama 3</strong></td> <td>Meta (Facebook AI Research)</td></tr> <tr><td><strong>SmolLM2</strong></td> <td>Hugging Face</td></tr> <tr><td><strong>Gemma</strong></td> <td>Google</td></tr> <tr><td><strong>Mistral</strong></td> <td>Mistral</td></tr></tbody>",Ye,U,ln="The underlying principle of an LLM is simple yet highly effective: <strong>its objective is to predict the next token, given a sequence of previous tokens</strong>. A “token” is the unit of information an LLM works with. You can think of a “token” as if it was a “word”, but for efficiency reasons LLMs don’t use whole words.",Ve,B,rn="For example, while English has an estimated 600,000 words, an LLM might have a vocabulary of around 32,000 tokens (as is the case with Llama 2). Tokenization often works on sub-word units that can be combined.",Je,O,an="For instance, consider how the tokens “interest” and “ing” can be combined to form “interesting”, or “ed” can be appended to form “interested.”",Ke,j,un="You can experiment with different tokenizers in the interactive playground below:",Qe,m,pn,Xe,W,hn="Each LLM has some <strong>special tokens</strong> specific to the model. The LLM uses these tokens to open and close the structured components of its generation. For example, to indicate the start or end of a sequence, message, or response. Moreover, the input prompts that we pass to the model are also structured with special tokens. The most important of those is the <strong>End of sequence token</strong> (EOS).",Ze,N,mn="The forms of special tokens are highly diverse across model providers.",et,D,dn="The table below illustrates the diversity of special tokens.",tt,Y,fn="<thead><tr><th><strong>Model</strong></th> <th><strong>Provider</strong></th> <th><strong>EOS Token</strong></th> <th><strong>Functionality</strong></th></tr></thead> <tbody><tr><td><strong>GPT4</strong></td> <td>OpenAI</td> <td><code>&lt;|endoftext|&gt;</code></td> <td>End of message text</td></tr> <tr><td><strong>Llama 3</strong></td> <td>Meta (Facebook AI Research)</td> <td><code>&lt;|eot_id|&gt;</code></td> <td>End of sequence</td></tr> <tr><td><strong>Deepseek-R1</strong></td> <td>DeepSeek</td> <td><code>&lt;|end_of_sentence|&gt;</code></td> <td>End of message text</td></tr> <tr><td><strong>SmolLM2</strong></td> <td>Hugging Face</td> <td><code>&lt;|im_end|&gt;</code></td> <td>End of instruction or message</td></tr> <tr><td><strong>Gemma</strong></td> <td>Google</td> <td><code>&lt;end_of_turn&gt;</code></td> <td>End of conversation turn</td></tr></tbody>",nt,M,it,V,st,J,gn="LLMs are said to be <strong>autoregressive</strong>, meaning that <strong>the output from one pass becomes the input for the next one</strong>. This loop continues until the model predicts the next token to be the EOS token, at which point the model can stop.",ot,T,cn,lt,K,vn="In other words, an LLM will decode text until it reaches the EOS. But what happens during a single decoding loop?",rt,Q,Ln="While the full process can be quite technical for the purpose of learning agents, here’s a brief overview:",at,X,wn="<li>Once the input text is <strong>tokenized</strong>, the model computes a representation of the sequence that captures information about the meaning and the position of each token in the input sequence.</li> <li>This representation goes into the model, which outputs scores that rank the likelihood of each token in its vocabulary as being the next one in the sequence.</li>",ut,b,xn,pt,Z,Mn="Based on these scores, we have multiple strategies to select the tokens to complete the sentence.",ht,ee,Tn="<li>The easiest decoding strategy would be to always take the token with the maximum score.</li>",mt,te,bn="You can interact with the decoding process yourself with SmolLM2 in this Space (remember, it decodes until reaching an <strong>EOS</strong> token which is  <strong>&lt;|im_end|&gt;</strong> for this model):",dt,d,kn,ft,ne,_n="<li>But there are more advanced decoding strategies. For example, <em>beam search</em> explores multiple candidate sequences to find the one with the maximum total score–even if some individual tokens have lower scores.</li>",gt,f,yn,ct,ie,Cn='If you want to know more about decoding, you can take a look at the <a href="https://huggingface.co/learn/nlp-course" rel="nofollow">NLP course</a>.',vt,se,Lt,oe,$n=`A key aspect of the Transformer architecture is <strong>Attention</strong>. When predicting the next word,
not every word in a sentence is equally important; words like “France” and “capital” in the sentence <em>“The capital of France is …”</em> carry the most meaning.`,wt,k,Hn,xt,le,Pn="Although the basic principle of LLMs—predicting the next token—has remained consistent since GPT-2, there have been significant advancements in scaling neural networks and making the attention mechanism work for longer and longer sequences.",Mt,re,An="If you’ve interacted with LLMs, you’re probably familiar with the term <em>context length</em>, which refers to the maximum number of tokens the LLM can process, and the maximum <em>attention span</em> it has.",Tt,ae,bt,ue,En="Considering that the only job of an LLM is to predict the next token by looking at every input token, and to choose which tokens are “important”, the wording of your input sequence is very important.",kt,pe,qn="The input sequence you provide an LLM is called <em>a prompt</em>. Careful design of the prompt makes it easier <strong>to guide the generation of the LLM toward the desired output</strong>.",_t,he,yt,me,In="LLMs are trained on large datasets of text, where they learn to predict the next word in a sequence through a self-supervised or masked language modeling objective.",Ct,de,Fn="From this unsupervised learning, the model learns the structure of the language and <strong>underlying patterns in text, allowing the model to generalize to unseen data</strong>.",$t,fe,Sn="After this initial <em>pre-training</em>, LLMs can be fine-tuned on a supervised learning objective to perform specific tasks. For example, some models are trained for conversational structures or tool usage, while others focus on classification or code generation.",Ht,ge,Pt,ce,zn="You have two main options:",At,ve,Gn="<li><p><strong>Run Locally</strong> (if you have sufficient hardware).</p></li> <li><p><strong>Use a Cloud/API</strong> (e.g., via the Hugging Face Serverless Inference API).</p></li>",Et,Le,Rn="Throughout this course, we will primarily use models via APIs on the Hugging Face Hub. Later on, we will explore how to run these models locally on your hardware.",qt,we,It,xe,Un="LLMs are a key component of AI Agents, <strong>providing the foundation for understanding and generating human language</strong>.",Ft,Me,Bn="They can interpret user instructions, maintain context in conversations, define a plan and decide which tools to use.",St,Te,On="We will explore these steps in more detail in this Unit, but for now, what you need to understand is that the LLM is <strong>the brain of the Agent</strong>.",zt,Gt,Rt,be,jn="That was a lot of information! We’ve covered the basics of what LLMs are, how they function, and their role in powering AI agents.",Ut,ke,Wn='If you’d like to dive even deeper into the fascinating world of language models and natural language processing, don’t hesitate to check out our <a href="https://huggingface.co/learn/nlp-course/chapter1/1" target="_blank">free NLP course</a>.',Bt,_e,Nn="Now that we understand how LLMs work, it’s time to see <strong>how LLMs structure their generations in a conversational context</strong>.",Ot,ye,Dn='To run <a href="https://huggingface.co/agents-course/notebooks/blob/main/dummy_agent_library.ipynb" target="_blank">this notebook</a>, <strong>you need a Hugging Face token</strong> that you can get from <a href="https://hf.co/settings/tokens" target="_blank">https://hf.co/settings/tokens</a>.',jt,Ce,Yn='For more information on how to run Jupyter Notebooks, checkout <a href="https://huggingface.co/docs/hub/notebooks">Jupyter Notebooks on the Hugging Face Hub</a>.',Wt,$e,Vn='You also need to request access to <a href="https://huggingface.co/meta-llama/Llama-3.2-3B-Instruct" target="_blank">the Meta Llama models</a>.',Nt,He,Dt,Ee,Yt;return C=new _({props:{title:"What are LLMs?",local:"what-are-llms",headingTag:"h1"}}),E=new _({props:{title:"What is a Large Language Model?",local:"what-is-a-large-language-model",headingTag:"h2"}}),M=new oi({props:{$$slots:{default:[ri]},$$scope:{ctx:Ie}}}),V=new _({props:{title:"Understanding next token prediction.",local:"understanding-next-token-prediction",headingTag:"h2"}}),se=new _({props:{title:"Attention is all you need",local:"attention-is-all-you-need",headingTag:"h2"}}),ae=new _({props:{title:"Prompting the LLM is important",local:"prompting-the-llm-is-important",headingTag:"h2"}}),he=new _({props:{title:"How are LLMs trained?",local:"how-are-llms-trained",headingTag:"h2"}}),ge=new _({props:{title:"How can I use LLMs?",local:"how-can-i-use-llms",headingTag:"h2"}}),we=new _({props:{title:"How are LLMs used in AI Agents?",local:"how-are-llms-used-in-ai-agents",headingTag:"h2"}}),He=new li({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/unit1/what-are-llms.mdx"}}),{c(){p=l("meta"),y=s(),h=l("p"),Ae=s(),g(C.$$.fragment),Fe=s(),$=l("img"),Se=s(),H=l("p"),H.innerHTML=Jt,ze=s(),P=l("p"),P.textContent=Kt,Ge=s(),A=l("p"),A.innerHTML=Qt,Re=s(),g(E.$$.fragment),Ue=s(),q=l("p"),q.innerHTML=Xt,Be=s(),I=l("p"),I.innerHTML=Zt,Oe=s(),F=l("figure"),F.innerHTML=en,je=s(),S=l("p"),S.textContent=tn,We=s(),z=l("ol"),z.innerHTML=nn,Ne=s(),G=l("p"),G.textContent=sn,De=s(),R=l("table"),R.innerHTML=on,Ye=s(),U=l("p"),U.innerHTML=ln,Ve=s(),B=l("p"),B.textContent=rn,Je=s(),O=l("p"),O.textContent=an,Ke=s(),j=l("p"),j.textContent=un,Qe=s(),m=l("iframe"),Xe=s(),W=l("p"),W.innerHTML=hn,Ze=s(),N=l("p"),N.textContent=mn,et=s(),D=l("p"),D.textContent=dn,tt=s(),Y=l("table"),Y.innerHTML=fn,nt=s(),g(M.$$.fragment),it=s(),g(V.$$.fragment),st=s(),J=l("p"),J.innerHTML=gn,ot=s(),T=l("img"),lt=s(),K=l("p"),K.textContent=vn,rt=s(),Q=l("p"),Q.textContent=Ln,at=s(),X=l("ul"),X.innerHTML=wn,ut=s(),b=l("img"),pt=s(),Z=l("p"),Z.textContent=Mn,ht=s(),ee=l("ul"),ee.innerHTML=Tn,mt=s(),te=l("p"),te.innerHTML=bn,dt=s(),d=l("iframe"),ft=s(),ne=l("ul"),ne.innerHTML=_n,gt=s(),f=l("iframe"),ct=s(),ie=l("p"),ie.innerHTML=Cn,vt=s(),g(se.$$.fragment),Lt=s(),oe=l("p"),oe.innerHTML=$n,wt=s(),k=l("img"),xt=ti(`
This process of identifying the most relevant words to predict the next token has proven to be incredibly effective.
`),le=l("p"),le.textContent=Pn,Mt=s(),re=l("p"),re.innerHTML=An,Tt=s(),g(ae.$$.fragment),bt=s(),ue=l("p"),ue.textContent=En,kt=s(),pe=l("p"),pe.innerHTML=qn,_t=s(),g(he.$$.fragment),yt=s(),me=l("p"),me.textContent=In,Ct=s(),de=l("p"),de.innerHTML=Fn,$t=s(),fe=l("p"),fe.innerHTML=Sn,Ht=s(),g(ge.$$.fragment),Pt=s(),ce=l("p"),ce.textContent=zn,At=s(),ve=l("ol"),ve.innerHTML=Gn,Et=s(),Le=l("p"),Le.textContent=Rn,qt=s(),g(we.$$.fragment),It=s(),xe=l("p"),xe.innerHTML=Un,Ft=s(),Me=l("p"),Me.textContent=Bn,St=s(),Te=l("p"),Te.innerHTML=On,zt=s(),Gt=l("hr"),Rt=s(),be=l("p"),be.textContent=jn,Ut=s(),ke=l("p"),ke.innerHTML=Wn,Bt=s(),_e=l("p"),_e.innerHTML=Nn,Ot=s(),ye=l("p"),ye.innerHTML=Dn,jt=s(),Ce=l("p"),Ce.innerHTML=Yn,Wt=s(),$e=l("p"),$e.innerHTML=Vn,Nt=s(),g(He.$$.fragment),Dt=s(),Ee=l("p"),this.h()},l(e){const t=ni("svelte-u9bgzb",document.head);p=r(t,"META",{name:!0,content:!0}),t.forEach(n),y=o(e),h=r(e,"P",{}),qe(h).forEach(n),Ae=o(e),c(C.$$.fragment,e),Fe=o(e),$=r(e,"IMG",{src:!0,alt:!0}),Se=o(e),H=r(e,"P",{"data-svelte-h":!0}),a(H)!=="svelte-eu1btd"&&(H.innerHTML=Jt),ze=o(e),P=r(e,"P",{"data-svelte-h":!0}),a(P)!=="svelte-5r6vmo"&&(P.textContent=Kt),Ge=o(e),A=r(e,"P",{"data-svelte-h":!0}),a(A)!=="svelte-1rvwwz3"&&(A.innerHTML=Qt),Re=o(e),c(E.$$.fragment,e),Ue=o(e),q=r(e,"P",{"data-svelte-h":!0}),a(q)!=="svelte-1my5lqi"&&(q.innerHTML=Xt),Be=o(e),I=r(e,"P",{"data-svelte-h":!0}),a(I)!=="svelte-uausky"&&(I.innerHTML=Zt),Oe=o(e),F=r(e,"FIGURE",{"data-svelte-h":!0}),a(F)!=="svelte-1ir35a8"&&(F.innerHTML=en),je=o(e),S=r(e,"P",{"data-svelte-h":!0}),a(S)!=="svelte-twq6h9"&&(S.textContent=tn),We=o(e),z=r(e,"OL",{"data-svelte-h":!0}),a(z)!=="svelte-1la424z"&&(z.innerHTML=nn),Ne=o(e),G=r(e,"P",{"data-svelte-h":!0}),a(G)!=="svelte-ve5xf3"&&(G.textContent=sn),De=o(e),R=r(e,"TABLE",{"data-svelte-h":!0}),a(R)!=="svelte-ehemmz"&&(R.innerHTML=on),Ye=o(e),U=r(e,"P",{"data-svelte-h":!0}),a(U)!=="svelte-1p4vse1"&&(U.innerHTML=ln),Ve=o(e),B=r(e,"P",{"data-svelte-h":!0}),a(B)!=="svelte-3ecqa9"&&(B.textContent=rn),Je=o(e),O=r(e,"P",{"data-svelte-h":!0}),a(O)!=="svelte-5d3cwd"&&(O.textContent=an),Ke=o(e),j=r(e,"P",{"data-svelte-h":!0}),a(j)!=="svelte-3xrazl"&&(j.textContent=un),Qe=o(e),m=r(e,"IFRAME",{src:!0,frameborder:!0,width:!0,height:!0}),qe(m).forEach(n),Xe=o(e),W=r(e,"P",{"data-svelte-h":!0}),a(W)!=="svelte-hdd8du"&&(W.innerHTML=hn),Ze=o(e),N=r(e,"P",{"data-svelte-h":!0}),a(N)!=="svelte-1r5sccr"&&(N.textContent=mn),et=o(e),D=r(e,"P",{"data-svelte-h":!0}),a(D)!=="svelte-1lxqmt8"&&(D.textContent=dn),tt=o(e),Y=r(e,"TABLE",{"data-svelte-h":!0}),a(Y)!=="svelte-oa6538"&&(Y.innerHTML=fn),nt=o(e),c(M.$$.fragment,e),it=o(e),c(V.$$.fragment,e),st=o(e),J=r(e,"P",{"data-svelte-h":!0}),a(J)!=="svelte-1lio3tg"&&(J.innerHTML=gn),ot=o(e),T=r(e,"IMG",{src:!0,alt:!0,width:!0}),lt=o(e),K=r(e,"P",{"data-svelte-h":!0}),a(K)!=="svelte-2b336t"&&(K.textContent=vn),rt=o(e),Q=r(e,"P",{"data-svelte-h":!0}),a(Q)!=="svelte-1nrwqur"&&(Q.textContent=Ln),at=o(e),X=r(e,"UL",{"data-svelte-h":!0}),a(X)!=="svelte-10a7glf"&&(X.innerHTML=wn),ut=o(e),b=r(e,"IMG",{src:!0,alt:!0,width:!0}),pt=o(e),Z=r(e,"P",{"data-svelte-h":!0}),a(Z)!=="svelte-u55g1b"&&(Z.textContent=Mn),ht=o(e),ee=r(e,"UL",{"data-svelte-h":!0}),a(ee)!=="svelte-1u2o7o8"&&(ee.innerHTML=Tn),mt=o(e),te=r(e,"P",{"data-svelte-h":!0}),a(te)!=="svelte-9jdmnd"&&(te.innerHTML=bn),dt=o(e),d=r(e,"IFRAME",{src:!0,frameborder:!0,width:!0,height:!0}),qe(d).forEach(n),ft=o(e),ne=r(e,"UL",{"data-svelte-h":!0}),a(ne)!=="svelte-1wwqz0"&&(ne.innerHTML=_n),gt=o(e),f=r(e,"IFRAME",{src:!0,frameborder:!0,width:!0,height:!0}),qe(f).forEach(n),ct=o(e),ie=r(e,"P",{"data-svelte-h":!0}),a(ie)!=="svelte-92nau4"&&(ie.innerHTML=Cn),vt=o(e),c(se.$$.fragment,e),Lt=o(e),oe=r(e,"P",{"data-svelte-h":!0}),a(oe)!=="svelte-pndgar"&&(oe.innerHTML=$n),wt=o(e),k=r(e,"IMG",{src:!0,alt:!0,width:!0}),xt=ii(e,`
This process of identifying the most relevant words to predict the next token has proven to be incredibly effective.
`),le=r(e,"P",{"data-svelte-h":!0}),a(le)!=="svelte-1y8y05c"&&(le.textContent=Pn),Mt=o(e),re=r(e,"P",{"data-svelte-h":!0}),a(re)!=="svelte-1mqt4z4"&&(re.innerHTML=An),Tt=o(e),c(ae.$$.fragment,e),bt=o(e),ue=r(e,"P",{"data-svelte-h":!0}),a(ue)!=="svelte-1npkzie"&&(ue.textContent=En),kt=o(e),pe=r(e,"P",{"data-svelte-h":!0}),a(pe)!=="svelte-vowz0p"&&(pe.innerHTML=qn),_t=o(e),c(he.$$.fragment,e),yt=o(e),me=r(e,"P",{"data-svelte-h":!0}),a(me)!=="svelte-1ouwtwv"&&(me.textContent=In),Ct=o(e),de=r(e,"P",{"data-svelte-h":!0}),a(de)!=="svelte-hd87fb"&&(de.innerHTML=Fn),$t=o(e),fe=r(e,"P",{"data-svelte-h":!0}),a(fe)!=="svelte-vbk6zi"&&(fe.innerHTML=Sn),Ht=o(e),c(ge.$$.fragment,e),Pt=o(e),ce=r(e,"P",{"data-svelte-h":!0}),a(ce)!=="svelte-8ww3l6"&&(ce.textContent=zn),At=o(e),ve=r(e,"OL",{"data-svelte-h":!0}),a(ve)!=="svelte-dh2m5h"&&(ve.innerHTML=Gn),Et=o(e),Le=r(e,"P",{"data-svelte-h":!0}),a(Le)!=="svelte-1v5f3ub"&&(Le.textContent=Rn),qt=o(e),c(we.$$.fragment,e),It=o(e),xe=r(e,"P",{"data-svelte-h":!0}),a(xe)!=="svelte-v8qzt8"&&(xe.innerHTML=Un),Ft=o(e),Me=r(e,"P",{"data-svelte-h":!0}),a(Me)!=="svelte-1g2dn56"&&(Me.textContent=Bn),St=o(e),Te=r(e,"P",{"data-svelte-h":!0}),a(Te)!=="svelte-b0ms1x"&&(Te.innerHTML=On),zt=o(e),Gt=r(e,"HR",{}),Rt=o(e),be=r(e,"P",{"data-svelte-h":!0}),a(be)!=="svelte-1xw1xo4"&&(be.textContent=jn),Ut=o(e),ke=r(e,"P",{"data-svelte-h":!0}),a(ke)!=="svelte-kp6qmd"&&(ke.innerHTML=Wn),Bt=o(e),_e=r(e,"P",{"data-svelte-h":!0}),a(_e)!=="svelte-26r940"&&(_e.innerHTML=Nn),Ot=o(e),ye=r(e,"P",{"data-svelte-h":!0}),a(ye)!=="svelte-3tvl21"&&(ye.innerHTML=Dn),jt=o(e),Ce=r(e,"P",{"data-svelte-h":!0}),a(Ce)!=="svelte-1mvr0xn"&&(Ce.innerHTML=Yn),Wt=o(e),$e=r(e,"P",{"data-svelte-h":!0}),a($e)!=="svelte-cyasnq"&&($e.innerHTML=Vn),Nt=o(e),c(He.$$.fragment,e),Dt=o(e),Ee=r(e,"P",{}),qe(Ee).forEach(n),this.h()},h(){u(p,"name","hf:doc:metadata"),u(p,"content",ui),Pe($.src,Vt="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/whiteboard-check-1.jpg")||u($,"src",Vt),u($,"alt","Unit 1 planning"),Pe(m.src,pn="https://agents-course-the-tokenizer-playground.static.hf.space")||u(m,"src",pn),u(m,"frameborder","0"),u(m,"width","850"),u(m,"height","450"),Pe(T.src,cn="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/AutoregressionSchema.gif")||u(T,"src",cn),u(T,"alt","Visual Gif of autoregressive decoding"),u(T,"width","60%"),Pe(b.src,xn="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/DecodingFinal.gif")||u(b,"src",xn),u(b,"alt","Visual Gif of decoding"),u(b,"width","60%"),Pe(d.src,kn="https://agents-course-decoding-visualizer.hf.space")||u(d,"src",kn),u(d,"frameborder","0"),u(d,"width","850"),u(d,"height","450"),Pe(f.src,yn="https://agents-course-beam-search-visualizer.hf.space")||u(f,"src",yn),u(f,"frameborder","0"),u(f,"width","850"),u(f,"height","450"),Pe(k.src,Hn="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/AttentionSceneFinal.gif")||u(k,"src",Hn),u(k,"alt","Visual Gif of Attention"),u(k,"width","60%")},m(e,t){si(document.head,p),i(e,y,t),i(e,h,t),i(e,Ae,t),v(C,e,t),i(e,Fe,t),i(e,$,t),i(e,Se,t),i(e,H,t),i(e,ze,t),i(e,P,t),i(e,Ge,t),i(e,A,t),i(e,Re,t),v(E,e,t),i(e,Ue,t),i(e,q,t),i(e,Be,t),i(e,I,t),i(e,Oe,t),i(e,F,t),i(e,je,t),i(e,S,t),i(e,We,t),i(e,z,t),i(e,Ne,t),i(e,G,t),i(e,De,t),i(e,R,t),i(e,Ye,t),i(e,U,t),i(e,Ve,t),i(e,B,t),i(e,Je,t),i(e,O,t),i(e,Ke,t),i(e,j,t),i(e,Qe,t),i(e,m,t),i(e,Xe,t),i(e,W,t),i(e,Ze,t),i(e,N,t),i(e,et,t),i(e,D,t),i(e,tt,t),i(e,Y,t),i(e,nt,t),v(M,e,t),i(e,it,t),v(V,e,t),i(e,st,t),i(e,J,t),i(e,ot,t),i(e,T,t),i(e,lt,t),i(e,K,t),i(e,rt,t),i(e,Q,t),i(e,at,t),i(e,X,t),i(e,ut,t),i(e,b,t),i(e,pt,t),i(e,Z,t),i(e,ht,t),i(e,ee,t),i(e,mt,t),i(e,te,t),i(e,dt,t),i(e,d,t),i(e,ft,t),i(e,ne,t),i(e,gt,t),i(e,f,t),i(e,ct,t),i(e,ie,t),i(e,vt,t),v(se,e,t),i(e,Lt,t),i(e,oe,t),i(e,wt,t),i(e,k,t),i(e,xt,t),i(e,le,t),i(e,Mt,t),i(e,re,t),i(e,Tt,t),v(ae,e,t),i(e,bt,t),i(e,ue,t),i(e,kt,t),i(e,pe,t),i(e,_t,t),v(he,e,t),i(e,yt,t),i(e,me,t),i(e,Ct,t),i(e,de,t),i(e,$t,t),i(e,fe,t),i(e,Ht,t),v(ge,e,t),i(e,Pt,t),i(e,ce,t),i(e,At,t),i(e,ve,t),i(e,Et,t),i(e,Le,t),i(e,qt,t),v(we,e,t),i(e,It,t),i(e,xe,t),i(e,Ft,t),i(e,Me,t),i(e,St,t),i(e,Te,t),i(e,zt,t),i(e,Gt,t),i(e,Rt,t),i(e,be,t),i(e,Ut,t),i(e,ke,t),i(e,Bt,t),i(e,_e,t),i(e,Ot,t),i(e,ye,t),i(e,jt,t),i(e,Ce,t),i(e,Wt,t),i(e,$e,t),i(e,Nt,t),v(He,e,t),i(e,Dt,t),i(e,Ee,t),Yt=!0},p(e,[t]){const Jn={};t&2&&(Jn.$$scope={dirty:t,ctx:e}),M.$set(Jn)},i(e){Yt||(L(C.$$.fragment,e),L(E.$$.fragment,e),L(M.$$.fragment,e),L(V.$$.fragment,e),L(se.$$.fragment,e),L(ae.$$.fragment,e),L(he.$$.fragment,e),L(ge.$$.fragment,e),L(we.$$.fragment,e),L(He.$$.fragment,e),Yt=!0)},o(e){w(C.$$.fragment,e),w(E.$$.fragment,e),w(M.$$.fragment,e),w(V.$$.fragment,e),w(se.$$.fragment,e),w(ae.$$.fragment,e),w(he.$$.fragment,e),w(ge.$$.fragment,e),w(we.$$.fragment,e),w(He.$$.fragment,e),Yt=!1},d(e){e&&(n(y),n(h),n(Ae),n(Fe),n($),n(Se),n(H),n(ze),n(P),n(Ge),n(A),n(Re),n(Ue),n(q),n(Be),n(I),n(Oe),n(F),n(je),n(S),n(We),n(z),n(Ne),n(G),n(De),n(R),n(Ye),n(U),n(Ve),n(B),n(Je),n(O),n(Ke),n(j),n(Qe),n(m),n(Xe),n(W),n(Ze),n(N),n(et),n(D),n(tt),n(Y),n(nt),n(it),n(st),n(J),n(ot),n(T),n(lt),n(K),n(rt),n(Q),n(at),n(X),n(ut),n(b),n(pt),n(Z),n(ht),n(ee),n(mt),n(te),n(dt),n(d),n(ft),n(ne),n(gt),n(f),n(ct),n(ie),n(vt),n(Lt),n(oe),n(wt),n(k),n(xt),n(le),n(Mt),n(re),n(Tt),n(bt),n(ue),n(kt),n(pe),n(_t),n(yt),n(me),n(Ct),n(de),n($t),n(fe),n(Ht),n(Pt),n(ce),n(At),n(ve),n(Et),n(Le),n(qt),n(It),n(xe),n(Ft),n(Me),n(St),n(Te),n(zt),n(Gt),n(Rt),n(be),n(Ut),n(ke),n(Bt),n(_e),n(Ot),n(ye),n(jt),n(Ce),n(Wt),n($e),n(Nt),n(Dt),n(Ee)),n(p),x(C,e),x(E,e),x(M,e),x(V,e),x(se,e),x(ae,e),x(he,e),x(ge,e),x(we,e),x(He,e)}}}const ui='{"title":"What are LLMs?","local":"what-are-llms","sections":[{"title":"What is a Large Language Model?","local":"what-is-a-large-language-model","sections":[],"depth":2},{"title":"Understanding next token prediction.","local":"understanding-next-token-prediction","sections":[],"depth":2},{"title":"Attention is all you need","local":"attention-is-all-you-need","sections":[],"depth":2},{"title":"Prompting the LLM is important","local":"prompting-the-llm-is-important","sections":[],"depth":2},{"title":"How are LLMs trained?","local":"how-are-llms-trained","sections":[],"depth":2},{"title":"How can I use LLMs?","local":"how-can-i-use-llms","sections":[],"depth":2},{"title":"How are LLMs used in AI Agents?","local":"how-are-llms-used-in-ai-agents","sections":[],"depth":2}],"depth":1}';function pi(Ie){return Qn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ci extends Zn{constructor(p){super(),ei(this,p,pi,ai,Kn,{})}}export{ci as component};
