import{s as nt,f as et,o as it,n as st}from"../chunks/scheduler.889ebb13.js";import{S as at,i as lt,g as l,s,r as m,A as ot,h as o,f as n,c as a,j as tt,u,x as r,k as X,y as rt,a as i,v as c,d as f,t as p,w as d}from"../chunks/index.ca18042b.js";import{T as gt}from"../chunks/Tip.b8116e3c.js";import{H as w}from"../chunks/Heading.3daa581c.js";import{E as mt}from"../chunks/EditOnGithub.2e95618d.js";function ut(ee){let g,v="In this unit, you will learn to build AI agents with the <code>smolagents</code> library. Your agents will be able to search for data, execute code, and interact with web pages. You will also learn how to combine multiple agents to create more powerful systems.";return{c(){g=l("p"),g.innerHTML=v},l(h){g=o(h,"P",{"data-svelte-h":!0}),r(g)!=="svelte-4kdknu"&&(g.innerHTML=v)},m(h,Q){i(h,g,Q)},p:st,d(h){h&&n(g)}}}function ct(ee){let g,v,h,Q,b,te,y,Re,ne,T,qe='Welcome to this module, where you’ll learn <strong>how to build effective agents</strong> using the <a href="https://github.com/huggingface/smolagents" rel="nofollow"><code>smolagents</code></a> library, which provides a lightweight framework for creating capable AI agents.',ie,x,Ie='<code>smolagents</code> is a Hugging Face library; therefore, we would appreciate your support by <strong>starring</strong> the smolagents <a href="https://github.com/huggingface/smolagents" rel="nofollow"><code>repository</code></a> :',se,_,Ue,ae,M,le,L,We="This module provides a comprehensive overview of key concepts and practical strategies for building intelligent agents using <code>smolagents</code>.",oe,C,ze="With so many open-source frameworks available, it’s essential to understand the components and capabilities that make <code>smolagents</code> a useful option or to determine when another solution might be a better fit.",re,k,Ee="We’ll explore critical agent types, including code agents designed for software development tasks, tool calling agents for creating modular, function-driven workflows, and retrieval agents that access and synthesize information.",ge,H,Oe="Additionally, we’ll cover the orchestration of multiple agents as well as the integration of vision capabilities and web browsing, which unlock new possibilities for dynamic and context-aware applications.",me,A,Se="In this unit, Alfred, the agent from Unit 1, makes his return. This time, he’s using the <code>smolagents</code> framework for his internal workings. Together, we’ll explore the key concepts behind this framework as Alfred tackles various tasks. Alfred is organizing a party at the Wayne Manor while the Wayne family 🦇 is away, and he has plenty to do. Join us as we showcase his journey and how he handles these tasks with <code>smolagents</code>!",ue,$,ce,P,Be='<img src="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/this-is-alfred.jpg" alt="Alfred the agent"/>',fe,G,pe,j,Ve="During this unit on <code>smolagents</code>, we cover:",de,R,he,q,Je="<code>smolagents</code> is one of the many open-source agent frameworks available for application development. Alternative options include <code>LlamaIndex</code> and <code>LangGraph</code>, which are also covered in other modules in this course. <code>smolagents</code> offers several key features that might make it a great fit for specific use cases, but we should always consider all options when selecting a framework. We’ll explore the advantages and drawbacks of using <code>smolagents</code>, helping you make an informed decision based on your project’s requirements.",we,I,$e,U,Ye="<code>CodeAgents</code> are the primary type of agent in <code>smolagents</code>. Instead of generating JSON or text, these agents produce Python code to perform actions. This module explores their purpose, functionality, and how they work, along with hands-on examples to showcase their capabilities.",ve,W,be,z,De="<code>ToolCallingAgents</code> are the second type of agent supported by <code>smolagents</code>. Unlike <code>CodeAgents</code>, which generate Python code, these agents rely on JSON/text blobs that the system must parse and interpret to execute actions. This module covers their functionality, their key differences from <code>CodeAgents</code>, and it provides an example to illustrate their usage.",ye,E,Te,O,Fe="As we saw in Unit 1, tools are functions that an LLM can use within an agentic system, and they act as the essential building blocks for agent behavior. This module covers how to create tools, their structure, and different implementation methods using the <code>Tool</code> class or the <code>@tool</code> decorator. You’ll also learn about the default toolbox, how to share tools with the community, and how to load community-contributed tools for use in your agents.",xe,S,_e,B,Ne="Retrieval agents allow models access to knowledge bases, making it possible to search, synthesize, and retrieve information from multiple sources. They leverage vector stores for efficient retrieval and implement <strong>Retrieval-Augmented Generation (RAG)</strong> patterns. These agents are particularly useful for integrating web search with custom knowledge bases while maintaining conversation context through memory systems. This module explores implementation strategies, including fallback mechanisms for robust information retrieval.",Me,V,Le,J,Ke="Orchestrating multiple agents effectively is crucial for building powerful, multi-agent systems. By combining agents with different capabilities—such as a web search agent with a code execution agent—you can create more sophisticated solutions. This module focuses on designing, implementing, and managing multi-agent systems to maximize efficiency and reliability.",Ce,Y,ke,D,Qe="Vision agents extend traditional agent capabilities by incorporating <strong>Vision-Language Models (VLMs)</strong>, enabling them to process and interpret visual information. This module explores how to design and integrate VLM-powered agents, unlocking advanced functionalities like image-based reasoning, visual data analysis, and multimodal interactions.  We will also use vision agents to build a browser agent that can browse the web and extract information from it.",He,F,Ae,N,Xe='<li><a href="https://huggingface.co/docs/smolagents" rel="nofollow">smolagents Documentation</a> - Official docs for the smolagents library</li> <li><a href="https://www.anthropic.com/research/building-effective-agents" rel="nofollow">Building Effective Agents</a> - Research paper on agent architectures</li> <li><a href="https://huggingface.co/docs/smolagents/tutorials/building_good_agents" rel="nofollow">Agent Guidelines</a> - Best practices for building reliable agents</li> <li><a href="https://langchain-ai.github.io/langgraph/" rel="nofollow">LangGraph Agents</a> - Additional examples of agent implementations</li> <li><a href="https://platform.openai.com/docs/guides/function-calling" rel="nofollow">Function Calling Guide</a> - Understanding function calling in LLMs</li> <li><a href="https://www.pinecone.io/learn/retrieval-augmented-generation/" rel="nofollow">RAG Best Practices</a> - Guide to implementing effective RAG</li>',Pe,K,Ge,Z,je;return b=new w({props:{title:"Introduction to smolagents",local:"introduction-to-smolagents",headingTag:"h1"}}),M=new w({props:{title:"Module Overview",local:"module-overview",headingTag:"h2"}}),$=new gt({props:{$$slots:{default:[ut]},$$scope:{ctx:ee}}}),G=new w({props:{title:"Contents",local:"contents",headingTag:"h2"}}),R=new w({props:{title:"1️⃣ Why Use smolagents",local:"1-why-use-smolagents",headingTag:"h3"}}),I=new w({props:{title:"2️⃣ CodeAgents",local:"2-codeagents",headingTag:"h3"}}),W=new w({props:{title:"3️⃣ ToolCallingAgents",local:"3-toolcallingagents",headingTag:"h3"}}),E=new w({props:{title:"4️⃣ Tools",local:"4-tools",headingTag:"h3"}}),S=new w({props:{title:"5️⃣ Retrieval Agents",local:"5-retrieval-agents",headingTag:"h3"}}),V=new w({props:{title:"6️⃣ Multi-Agent Systems",local:"6-multi-agent-systems",headingTag:"h3"}}),Y=new w({props:{title:"7️⃣ Vision and Browser agents",local:"7-vision-and-browser-agents",headingTag:"h3"}}),F=new w({props:{title:"Resources",local:"resources",headingTag:"h2"}}),K=new mt({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/unit2/smolagents/introduction.mdx"}}),{c(){g=l("meta"),v=s(),h=l("p"),Q=s(),m(b.$$.fragment),te=s(),y=l("img"),ne=s(),T=l("p"),T.innerHTML=qe,ie=s(),x=l("p"),x.innerHTML=Ie,se=s(),_=l("img"),ae=s(),m(M.$$.fragment),le=s(),L=l("p"),L.innerHTML=We,oe=s(),C=l("p"),C.innerHTML=ze,re=s(),k=l("p"),k.textContent=Ee,ge=s(),H=l("p"),H.textContent=Oe,me=s(),A=l("p"),A.innerHTML=Se,ue=s(),m($.$$.fragment),ce=s(),P=l("p"),P.innerHTML=Be,fe=s(),m(G.$$.fragment),pe=s(),j=l("p"),j.innerHTML=Ve,de=s(),m(R.$$.fragment),he=s(),q=l("p"),q.innerHTML=Je,we=s(),m(I.$$.fragment),$e=s(),U=l("p"),U.innerHTML=Ye,ve=s(),m(W.$$.fragment),be=s(),z=l("p"),z.innerHTML=De,ye=s(),m(E.$$.fragment),Te=s(),O=l("p"),O.innerHTML=Fe,xe=s(),m(S.$$.fragment),_e=s(),B=l("p"),B.innerHTML=Ne,Me=s(),m(V.$$.fragment),Le=s(),J=l("p"),J.textContent=Ke,Ce=s(),m(Y.$$.fragment),ke=s(),D=l("p"),D.innerHTML=Qe,He=s(),m(F.$$.fragment),Ae=s(),N=l("ul"),N.innerHTML=Xe,Pe=s(),m(K.$$.fragment),Ge=s(),Z=l("p"),this.h()},l(e){const t=ot("svelte-u9bgzb",document.head);g=o(t,"META",{name:!0,content:!0}),t.forEach(n),v=a(e),h=o(e,"P",{}),tt(h).forEach(n),Q=a(e),u(b.$$.fragment,e),te=a(e),y=o(e,"IMG",{src:!0,alt:!0}),ne=a(e),T=o(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-1jxrui2"&&(T.innerHTML=qe),ie=a(e),x=o(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-16lqseq"&&(x.innerHTML=Ie),se=a(e),_=o(e,"IMG",{src:!0,alt:!0}),ae=a(e),u(M.$$.fragment,e),le=a(e),L=o(e,"P",{"data-svelte-h":!0}),r(L)!=="svelte-14xl1e4"&&(L.innerHTML=We),oe=a(e),C=o(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-qet0gp"&&(C.innerHTML=ze),re=a(e),k=o(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-ugm93p"&&(k.textContent=Ee),ge=a(e),H=o(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-1qniwjn"&&(H.textContent=Oe),me=a(e),A=o(e,"P",{"data-svelte-h":!0}),r(A)!=="svelte-aelzj0"&&(A.innerHTML=Se),ue=a(e),u($.$$.fragment,e),ce=a(e),P=o(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-13ihsp8"&&(P.innerHTML=Be),fe=a(e),u(G.$$.fragment,e),pe=a(e),j=o(e,"P",{"data-svelte-h":!0}),r(j)!=="svelte-1y4ype3"&&(j.innerHTML=Ve),de=a(e),u(R.$$.fragment,e),he=a(e),q=o(e,"P",{"data-svelte-h":!0}),r(q)!=="svelte-9gosxv"&&(q.innerHTML=Je),we=a(e),u(I.$$.fragment,e),$e=a(e),U=o(e,"P",{"data-svelte-h":!0}),r(U)!=="svelte-bjc1l"&&(U.innerHTML=Ye),ve=a(e),u(W.$$.fragment,e),be=a(e),z=o(e,"P",{"data-svelte-h":!0}),r(z)!=="svelte-196g81q"&&(z.innerHTML=De),ye=a(e),u(E.$$.fragment,e),Te=a(e),O=o(e,"P",{"data-svelte-h":!0}),r(O)!=="svelte-1lsa31s"&&(O.innerHTML=Fe),xe=a(e),u(S.$$.fragment,e),_e=a(e),B=o(e,"P",{"data-svelte-h":!0}),r(B)!=="svelte-s1bhqq"&&(B.innerHTML=Ne),Me=a(e),u(V.$$.fragment,e),Le=a(e),J=o(e,"P",{"data-svelte-h":!0}),r(J)!=="svelte-15o11ij"&&(J.textContent=Ke),Ce=a(e),u(Y.$$.fragment,e),ke=a(e),D=o(e,"P",{"data-svelte-h":!0}),r(D)!=="svelte-1gya1jz"&&(D.innerHTML=Qe),He=a(e),u(F.$$.fragment,e),Ae=a(e),N=o(e,"UL",{"data-svelte-h":!0}),r(N)!=="svelte-99c63t"&&(N.innerHTML=Xe),Pe=a(e),u(K.$$.fragment,e),Ge=a(e),Z=o(e,"P",{}),tt(Z).forEach(n),this.h()},h(){X(g,"name","hf:doc:metadata"),X(g,"content",ft),et(y.src,Re="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit2/smolagents/thumbnail.jpg")||X(y,"src",Re),X(y,"alt","Unit 2.1 Thumbnail"),et(_.src,Ue="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit2/smolagents/star_smolagents.gif")||X(_,"src",Ue),X(_,"alt","staring smolagents")},m(e,t){rt(document.head,g),i(e,v,t),i(e,h,t),i(e,Q,t),c(b,e,t),i(e,te,t),i(e,y,t),i(e,ne,t),i(e,T,t),i(e,ie,t),i(e,x,t),i(e,se,t),i(e,_,t),i(e,ae,t),c(M,e,t),i(e,le,t),i(e,L,t),i(e,oe,t),i(e,C,t),i(e,re,t),i(e,k,t),i(e,ge,t),i(e,H,t),i(e,me,t),i(e,A,t),i(e,ue,t),c($,e,t),i(e,ce,t),i(e,P,t),i(e,fe,t),c(G,e,t),i(e,pe,t),i(e,j,t),i(e,de,t),c(R,e,t),i(e,he,t),i(e,q,t),i(e,we,t),c(I,e,t),i(e,$e,t),i(e,U,t),i(e,ve,t),c(W,e,t),i(e,be,t),i(e,z,t),i(e,ye,t),c(E,e,t),i(e,Te,t),i(e,O,t),i(e,xe,t),c(S,e,t),i(e,_e,t),i(e,B,t),i(e,Me,t),c(V,e,t),i(e,Le,t),i(e,J,t),i(e,Ce,t),c(Y,e,t),i(e,ke,t),i(e,D,t),i(e,He,t),c(F,e,t),i(e,Ae,t),i(e,N,t),i(e,Pe,t),c(K,e,t),i(e,Ge,t),i(e,Z,t),je=!0},p(e,[t]){const Ze={};t&2&&(Ze.$$scope={dirty:t,ctx:e}),$.$set(Ze)},i(e){je||(f(b.$$.fragment,e),f(M.$$.fragment,e),f($.$$.fragment,e),f(G.$$.fragment,e),f(R.$$.fragment,e),f(I.$$.fragment,e),f(W.$$.fragment,e),f(E.$$.fragment,e),f(S.$$.fragment,e),f(V.$$.fragment,e),f(Y.$$.fragment,e),f(F.$$.fragment,e),f(K.$$.fragment,e),je=!0)},o(e){p(b.$$.fragment,e),p(M.$$.fragment,e),p($.$$.fragment,e),p(G.$$.fragment,e),p(R.$$.fragment,e),p(I.$$.fragment,e),p(W.$$.fragment,e),p(E.$$.fragment,e),p(S.$$.fragment,e),p(V.$$.fragment,e),p(Y.$$.fragment,e),p(F.$$.fragment,e),p(K.$$.fragment,e),je=!1},d(e){e&&(n(v),n(h),n(Q),n(te),n(y),n(ne),n(T),n(ie),n(x),n(se),n(_),n(ae),n(le),n(L),n(oe),n(C),n(re),n(k),n(ge),n(H),n(me),n(A),n(ue),n(ce),n(P),n(fe),n(pe),n(j),n(de),n(he),n(q),n(we),n($e),n(U),n(ve),n(be),n(z),n(ye),n(Te),n(O),n(xe),n(_e),n(B),n(Me),n(Le),n(J),n(Ce),n(ke),n(D),n(He),n(Ae),n(N),n(Pe),n(Ge),n(Z)),n(g),d(b,e),d(M,e),d($,e),d(G,e),d(R,e),d(I,e),d(W,e),d(E,e),d(S,e),d(V,e),d(Y,e),d(F,e),d(K,e)}}}const ft='{"title":"Introduction to smolagents","local":"introduction-to-smolagents","sections":[{"title":"Module Overview","local":"module-overview","sections":[],"depth":2},{"title":"Contents","local":"contents","sections":[{"title":"1️⃣ Why Use smolagents","local":"1-why-use-smolagents","sections":[],"depth":3},{"title":"2️⃣ CodeAgents","local":"2-codeagents","sections":[],"depth":3},{"title":"3️⃣ ToolCallingAgents","local":"3-toolcallingagents","sections":[],"depth":3},{"title":"4️⃣ Tools","local":"4-tools","sections":[],"depth":3},{"title":"5️⃣ Retrieval Agents","local":"5-retrieval-agents","sections":[],"depth":3},{"title":"6️⃣ Multi-Agent Systems","local":"6-multi-agent-systems","sections":[],"depth":3},{"title":"7️⃣ Vision and Browser agents","local":"7-vision-and-browser-agents","sections":[],"depth":3}],"depth":2},{"title":"Resources","local":"resources","sections":[],"depth":2}],"depth":1}';function pt(ee){return it(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class bt extends at{constructor(g){super(),lt(this,g,pt,ct,nt,{})}}export{bt as component};
