import{s as Te,n as Pe,o as ke}from"../chunks/scheduler.889ebb13.js";import{S as ze,i as Se,g as o,s as n,r,A as Qe,h as l,f as s,c as a,j as Ie,u as m,x as g,k as Me,y as Ae,a as i,v as p,d,t as c,w as u}from"../chunks/index.ca18042b.js";import{Q as O}from"../chunks/Question.e3bbda25.js";import{H as A}from"../chunks/Heading.3daa581c.js";import{E as We}from"../chunks/EditOnGithub.2e95618d.js";function Ne(we){let f,J,W,R,h,E,$,ye="Let’s test your understanding of <code>smolagents</code> with a quick quiz! Remember, testing yourself helps reinforce learning and identify areas that may need review.",j,b,xe="This is an optional quiz and it’s not graded.",F,w,Y,y,ve="Which statement best captures a core strength of the <code>smolagents</code> approach?",U,x,B,G,D,v,K,q,qe="Which situation aligns well with what smolagents does best?",V,L,X,Z,ee,C,te,H,Le="Choose the most accurate description of how smolagents interoperates with LLMs.",se,_,ie,ne,ae,I,oe,M,Ce="Which statement correctly characterizes smolagents’ philosophy about action formats?",le,T,re,me,pe,P,de,k,He="Which statement accurately describes one of the core advantages of Hub integration?",ce,z,ue,fe,ge,S,_e="Congratulations on completing this quiz! 🎉 If you missed any questions, consider reviewing the <em>Why use smolagents</em> section for a deeper understanding. If you did well, you’re ready to explore more advanced topics in smolagents!",he,Q,$e,N,be;return h=new A({props:{title:"Small Quiz (ungraded)",local:"quiz1",headingTag:"h1"}}),w=new A({props:{title:"Q1: What is one of the primary advantages of choosing smolagents over other frameworks?",local:"q1-what-is-one-of-the-primary-advantages-of-choosing-smolagents-over-other-frameworks",headingTag:"h3"}}),x=new O({props:{choices:[{text:"It uses highly specialized configuration files and a steep learning curve to ensure only expert developers can use it",explain:"smolagents is designed for simplicity and minimal code complexity, not steep learning curves."},{text:"It supports a code-first approach with minimal abstractions, letting agents interact directly via Python function calls",explain:"Yes, smolagents emphasizes a straightforward, code-centric design with minimal abstractions.",correct:!0},{text:"It focuses on JSON-based actions, removing the need for agents to write any code",explain:"While smolagents supports JSON-based tool calls (ToolCallingAgents), the library emphasizes code-based approaches with CodeAgents."},{text:"It deeply integrates with a single LLM provider and specialized hardware",explain:"smolagents supports multiple model providers and does not require specialized hardware."}]}}),v=new A({props:{title:"Q2: In which scenario would you likely benefit most from using smolagents?",local:"q2-in-which-scenario-would-you-likely-benefit-most-from-using-smolagents",headingTag:"h3"}}),L=new O({props:{choices:[{text:"Prototyping or experimenting quickly with agent logic, particularly when your application is relatively straightforward",explain:"Yes. smolagents is designed for simple and nimble agent creation without extensive setup overhead.",correct:!0},{text:"Building a large-scale enterprise system where you need dozens of microservices and real-time data pipelines",explain:"While possible, smolagents is more focused on lightweight, code-centric experimentation rather than heavy enterprise infrastructure."},{text:"Needing a framework that only supports cloud-based LLMs and forbids local inference",explain:"smolagents offers flexible integration with local or hosted models, not exclusively cloud-based LLMs."},{text:"A scenario that requires advanced orchestration, multi-modal perception, and enterprise-scale features out-of-the-box",explain:"While you can integrate advanced capabilities, smolagents itself is lightweight and minimal at its core."}]}}),C=new A({props:{title:"Q3: smolagents offers flexibility in model integration. Which statement best reflects its approach?",local:"q3-smolagents-offers-flexibility-in-model-integration-which-statement-best-reflects-its-approach",headingTag:"h3"}}),_=new O({props:{choices:[{text:"It only provides a single built-in model and does not allow custom integrations",explain:"smolagents supports multiple different backends and user-defined models."},{text:"It requires you to implement your own model connector for every LLM usage",explain:"There are multiple prebuilt connectors that make LLM integration straightforward."},{text:"It only integrates with open-source LLMs but not commercial APIs",explain:"smolagents can integrate with both open-source and commercial model APIs."},{text:"It can be used with a wide range of LLMs, offering predefined classes like TransformersModel, HfApiModel, and LiteLLMModel",explain:"This is correct. smolagents supports flexible model integration through various classes.",correct:!0}]}}),I=new A({props:{title:"Q4: How does smolagents handle the debate between code-based actions and JSON-based actions?",local:"q4-how-does-smolagents-handle-the-debate-between-code-based-actions-and-json-based-actions",headingTag:"h3"}}),T=new O({props:{choices:[{text:"It only allows JSON-based actions for all agent tasks, requiring a parser to extract the tool calls",explain:"ToolCallingAgent uses JSON-based calls, but smolagents also provides a primary CodeAgent option that writes Python code."},{text:"It focuses on code-based actions via a CodeAgent but also supports JSON-based tool calls with a ToolCallingAgent",explain:"Yes, smolagents primarily recommends code-based actions but includes a JSON-based alternative for users who prefer it or need it.",correct:!0},{text:"It disallows any external function calls, instead requiring all logic to reside entirely within the LLM",explain:"smolagents is specifically designed to grant LLMs the ability to call tools or code externally."},{text:"It requires users to manually convert every code snippet into a JSON object before running the agent",explain:"smolagents can automatically manage code snippet creation within the CodeAgent path, no manual JSON conversion necessary."}]}}),P=new A({props:{title:"Q5: How does smolagents integrate with the Hugging Face Hub for added benefits?",local:"q5-how-does-smolagents-integrate-with-the-hugging-face-hub-for-added-benefits",headingTag:"h3"}}),z=new O({props:{choices:[{text:"It automatically upgrades all public models to commercial license tiers",explain:"Hub integration doesn't change the license tier for models or tools."},{text:"It disables local inference entirely, forcing remote model usage only",explain:"Users can still do local inference if they prefer; pushing to the Hub doesn't override local usage."},{text:"It allows you to push and share agents or tools, making them easily discoverable and reusable by other developers",explain:"Correct. smolagents supports uploading agents and tools to the HF Hub for others to reuse.",correct:!0},{text:"It permanently stores all your code-based agents, preventing any updates or versioning",explain:"Hub repositories support updates and version control, so you can revise your code-based agents any time."}]}}),Q=new We({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/unit2/smolagents/quiz1.mdx"}}),{c(){f=o("meta"),J=n(),W=o("p"),R=n(),r(h.$$.fragment),E=n(),$=o("p"),$.innerHTML=ye,j=n(),b=o("p"),b.textContent=xe,F=n(),r(w.$$.fragment),Y=n(),y=o("p"),y.innerHTML=ve,U=n(),r(x.$$.fragment),B=n(),G=o("hr"),D=n(),r(v.$$.fragment),K=n(),q=o("p"),q.textContent=qe,V=n(),r(L.$$.fragment),X=n(),Z=o("hr"),ee=n(),r(C.$$.fragment),te=n(),H=o("p"),H.textContent=Le,se=n(),r(_.$$.fragment),ie=n(),ne=o("hr"),ae=n(),r(I.$$.fragment),oe=n(),M=o("p"),M.textContent=Ce,le=n(),r(T.$$.fragment),re=n(),me=o("hr"),pe=n(),r(P.$$.fragment),de=n(),k=o("p"),k.textContent=He,ce=n(),r(z.$$.fragment),ue=n(),fe=o("hr"),ge=n(),S=o("p"),S.innerHTML=_e,he=n(),r(Q.$$.fragment),$e=n(),N=o("p"),this.h()},l(e){const t=Qe("svelte-u9bgzb",document.head);f=l(t,"META",{name:!0,content:!0}),t.forEach(s),J=a(e),W=l(e,"P",{}),Ie(W).forEach(s),R=a(e),m(h.$$.fragment,e),E=a(e),$=l(e,"P",{"data-svelte-h":!0}),g($)!=="svelte-wc40qz"&&($.innerHTML=ye),j=a(e),b=l(e,"P",{"data-svelte-h":!0}),g(b)!=="svelte-12v6wzc"&&(b.textContent=xe),F=a(e),m(w.$$.fragment,e),Y=a(e),y=l(e,"P",{"data-svelte-h":!0}),g(y)!=="svelte-9oeyap"&&(y.innerHTML=ve),U=a(e),m(x.$$.fragment,e),B=a(e),G=l(e,"HR",{}),D=a(e),m(v.$$.fragment,e),K=a(e),q=l(e,"P",{"data-svelte-h":!0}),g(q)!=="svelte-1o8ymmc"&&(q.textContent=qe),V=a(e),m(L.$$.fragment,e),X=a(e),Z=l(e,"HR",{}),ee=a(e),m(C.$$.fragment,e),te=a(e),H=l(e,"P",{"data-svelte-h":!0}),g(H)!=="svelte-awo3oy"&&(H.textContent=Le),se=a(e),m(_.$$.fragment,e),ie=a(e),ne=l(e,"HR",{}),ae=a(e),m(I.$$.fragment,e),oe=a(e),M=l(e,"P",{"data-svelte-h":!0}),g(M)!=="svelte-up6j5y"&&(M.textContent=Ce),le=a(e),m(T.$$.fragment,e),re=a(e),me=l(e,"HR",{}),pe=a(e),m(P.$$.fragment,e),de=a(e),k=l(e,"P",{"data-svelte-h":!0}),g(k)!=="svelte-r09q7d"&&(k.textContent=He),ce=a(e),m(z.$$.fragment,e),ue=a(e),fe=l(e,"HR",{}),ge=a(e),S=l(e,"P",{"data-svelte-h":!0}),g(S)!=="svelte-4knnib"&&(S.innerHTML=_e),he=a(e),m(Q.$$.fragment,e),$e=a(e),N=l(e,"P",{}),Ie(N).forEach(s),this.h()},h(){Me(f,"name","hf:doc:metadata"),Me(f,"content",Oe)},m(e,t){Ae(document.head,f),i(e,J,t),i(e,W,t),i(e,R,t),p(h,e,t),i(e,E,t),i(e,$,t),i(e,j,t),i(e,b,t),i(e,F,t),p(w,e,t),i(e,Y,t),i(e,y,t),i(e,U,t),p(x,e,t),i(e,B,t),i(e,G,t),i(e,D,t),p(v,e,t),i(e,K,t),i(e,q,t),i(e,V,t),p(L,e,t),i(e,X,t),i(e,Z,t),i(e,ee,t),p(C,e,t),i(e,te,t),i(e,H,t),i(e,se,t),p(_,e,t),i(e,ie,t),i(e,ne,t),i(e,ae,t),p(I,e,t),i(e,oe,t),i(e,M,t),i(e,le,t),p(T,e,t),i(e,re,t),i(e,me,t),i(e,pe,t),p(P,e,t),i(e,de,t),i(e,k,t),i(e,ce,t),p(z,e,t),i(e,ue,t),i(e,fe,t),i(e,ge,t),i(e,S,t),i(e,he,t),p(Q,e,t),i(e,$e,t),i(e,N,t),be=!0},p:Pe,i(e){be||(d(h.$$.fragment,e),d(w.$$.fragment,e),d(x.$$.fragment,e),d(v.$$.fragment,e),d(L.$$.fragment,e),d(C.$$.fragment,e),d(_.$$.fragment,e),d(I.$$.fragment,e),d(T.$$.fragment,e),d(P.$$.fragment,e),d(z.$$.fragment,e),d(Q.$$.fragment,e),be=!0)},o(e){c(h.$$.fragment,e),c(w.$$.fragment,e),c(x.$$.fragment,e),c(v.$$.fragment,e),c(L.$$.fragment,e),c(C.$$.fragment,e),c(_.$$.fragment,e),c(I.$$.fragment,e),c(T.$$.fragment,e),c(P.$$.fragment,e),c(z.$$.fragment,e),c(Q.$$.fragment,e),be=!1},d(e){e&&(s(J),s(W),s(R),s(E),s($),s(j),s(b),s(F),s(Y),s(y),s(U),s(B),s(G),s(D),s(K),s(q),s(V),s(X),s(Z),s(ee),s(te),s(H),s(se),s(ie),s(ne),s(ae),s(oe),s(M),s(le),s(re),s(me),s(pe),s(de),s(k),s(ce),s(ue),s(fe),s(ge),s(S),s(he),s($e),s(N)),s(f),u(h,e),u(w,e),u(x,e),u(v,e),u(L,e),u(C,e),u(_,e),u(I,e),u(T,e),u(P,e),u(z,e),u(Q,e)}}}const Oe='{"title":"Small Quiz (ungraded)","local":"quiz1","sections":[{"title":"Q1: What is one of the primary advantages of choosing smolagents over other frameworks?","local":"q1-what-is-one-of-the-primary-advantages-of-choosing-smolagents-over-other-frameworks","sections":[],"depth":3},{"title":"Q2: In which scenario would you likely benefit most from using smolagents?","local":"q2-in-which-scenario-would-you-likely-benefit-most-from-using-smolagents","sections":[],"depth":3},{"title":"Q3: smolagents offers flexibility in model integration. Which statement best reflects its approach?","local":"q3-smolagents-offers-flexibility-in-model-integration-which-statement-best-reflects-its-approach","sections":[],"depth":3},{"title":"Q4: How does smolagents handle the debate between code-based actions and JSON-based actions?","local":"q4-how-does-smolagents-handle-the-debate-between-code-based-actions-and-json-based-actions","sections":[],"depth":3},{"title":"Q5: How does smolagents integrate with the Hugging Face Hub for added benefits?","local":"q5-how-does-smolagents-integrate-with-the-hugging-face-hub-for-added-benefits","sections":[],"depth":3}],"depth":1}';function Je(we){return ke(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ue extends ze{constructor(f){super(),Se(this,f,Je,Ne,Te,{})}}export{Ue as component};
