import{s as it,o as at,n as rt}from"../chunks/scheduler.889ebb13.js";import{S as gt,i as mt,g as i,s as l,r as c,A as ft,h as a,f as n,c as o,j as lt,x as r,u as h,k as ot,y as pt,a as s,v as d,d as w,t as v,w as $,m as Oe,n as ze}from"../chunks/index.ca18042b.js";import{T as ut}from"../chunks/Tip.b8116e3c.js";import{H as C}from"../chunks/Heading.3daa581c.js";import{E as ct}from"../chunks/EditOnGithub.2e95618d.js";function ht(ne){let f,p,M="@tool",x,m,ee="Tool",L;return{c(){f=Oe("In smolagents, tools are defined using "),p=i("code"),p.textContent=M,x=Oe(" decorator wrapping a python function or the "),m=i("code"),m.textContent=ee,L=Oe(" class.")},l(g){f=ze(g,"In smolagents, tools are defined using "),p=a(g,"CODE",{"data-svelte-h":!0}),r(p)!=="svelte-1ni63dk"&&(p.textContent=M),x=ze(g," decorator wrapping a python function or the "),m=a(g,"CODE",{"data-svelte-h":!0}),r(m)!=="svelte-q1isru"&&(m.textContent=ee),L=ze(g," class.")},m(g,u){s(g,f,u),s(g,p,u),s(g,x,u),s(g,m,u),s(g,L,u)},p:rt,d(g){g&&(n(f),n(p),n(x),n(m),n(L))}}}function dt(ne){let f,p,M,x,m,ee='<img src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/smolagents/license_to_call.png" alt="smolagents banner"/>',L,g,u,y,Ee='In this module, we will explore the pros and cons of using <a href="https://huggingface.co/docs/smolagents/en/index" rel="nofollow">smolagents</a>, helping you make an informed decision about whether it’s the right framework for your needs.',se,_,le,H,We="<code>smolagents</code> is a simple yet powerful framework for building AI agents. It provides LLMs with the <em>agency</em> to interact with the real world, such as searching or generating images.",oe,A,je="As we learned in unit 1, AI agents are programs that use LLMs to generate <strong>‘thoughts’</strong> based on <strong>‘observations’</strong> to perform <strong>‘actions’</strong>. Let’s explore how this is implemented in smolagents.",ie,b,ae,P,Ne="<li><strong>Simplicity:</strong> Minimal code complexity and abstractions, to make the framework easy to understand, adopt and extend</li> <li><strong>Flexible LLM Support:</strong> Works with any LLM through integration with Hugging Face tools and external APIs</li> <li><strong>Code-First Approach:</strong> First-class support for Code Agents that write their actions directly in code, removing the need for parsing and simplifying tool calling</li> <li><strong>HF Hub Integration:</strong> Seamless integration with the Hugging Face Hub, allowing the use of Gradio Spaces as tools</li>",re,S,ge,I,Ue="With these advantages in mind, when should we use smolagents over other frameworks?",me,k,Fe="smolagents is ideal when:",fe,O,Je="<li>You need a <strong>lightweight and minimal solution.</strong></li> <li>You want to <strong>experiment quickly</strong> without complex configurations.</li> <li>Your <strong>application logic is straightforward.</strong></li>",pe,z,ue,E,qe="Unlike other frameworks where agents write actions in JSON, <code>smolagents</code> <strong>focuses on tool calls in code</strong>, simplifying the execution process. This is because there’s no need to parse the JSON in order to build code that calls the tools: the output can be executed directly.",ce,W,Re="The following diagram illustrates this difference:",he,j,Ye='<img src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/transformers/code_vs_json_actions.png" alt="Code vs. JSON actions"/>',de,N,De='To review the difference between Code vs JSON Actions, you can revisit <a href="https://huggingface.co/learn/agents-course/unit1/actions#actions-enabling-the-agent-to-engage-with-its-environment" rel="nofollow">the Actions Section in Unit 1</a>.',we,U,ve,F,Ge="Agents in <code>smolagents</code> operate as <strong>multi-step agents</strong>.",$e,J,Ke='Each <a href="https://huggingface.co/docs/smolagents/main/en/reference/agents#smolagents.MultiStepAgent" rel="nofollow"><code>MultiStepAgent</code></a> performs:',xe,q,Be="<li>One thought</li> <li>One tool call and execution</li>",Le,R,Qe='In addition to using <strong><a href="https://huggingface.co/docs/smolagents/main/en/reference/agents#smolagents.CodeAgent" rel="nofollow">CodeAgent</a></strong> as the primary type of agent, smolagents also supports <strong><a href="https://huggingface.co/docs/smolagents/main/en/reference/agents#smolagents.ToolCallingAgent" rel="nofollow">ToolCallingAgent</a></strong>, which writes tool calls in JSON.',Me,Y,Ve="We will explore each agent type in more detail in the following sections.",Te,T,Ce,D,ye,G,Xe='<code>smolagents</code> supports flexible LLM integration, allowing you to use any callable model that meets <a href="https://huggingface.co/docs/smolagents/main/en/reference/models" rel="nofollow">certain criteria</a>. The framework provides several predefined classes to simplify model connections:',_e,K,Ze='<li><strong><a href="https://huggingface.co/docs/smolagents/main/en/reference/models#smolagents.TransformersModel" rel="nofollow">TransformersModel</a>:</strong> Implements a local <code>transformers</code> pipeline for seamless integration.</li> <li><strong><a href="https://huggingface.co/docs/smolagents/main/en/reference/models#smolagents.HfApiModel" rel="nofollow">HfApiModel</a>:</strong> Supports <a href="https://huggingface.co/docs/huggingface_hub/main/en/guides/inference" rel="nofollow">serverless inference</a> calls through <a href="https://huggingface.co/docs/api-inference/index" rel="nofollow">Hugging Face’s infrastructure</a>, or via a growing number of <a href="https://huggingface.co/docs/huggingface_hub/main/en/guides/inference#supported-providers-and-tasks" rel="nofollow">third-party inference providers</a>.</li> <li><strong><a href="https://huggingface.co/docs/smolagents/main/en/reference/models#smolagents.LiteLLMModel" rel="nofollow">LiteLLMModel</a>:</strong> Leverages <a href="https://www.litellm.ai/" rel="nofollow">LiteLLM</a> for lightweight model interactions.</li> <li><strong><a href="https://huggingface.co/docs/smolagents/main/en/reference/models#smolagents.OpenAIServerModel" rel="nofollow">OpenAIServerModel</a>:</strong> Connects to any service that offers an OpenAI API interface.</li> <li><strong><a href="https://huggingface.co/docs/smolagents/main/en/reference/models#smolagents.AzureOpenAIServerModel" rel="nofollow">AzureOpenAIServerModel</a>:</strong> Supports integration with any Azure OpenAI deployment.</li>',He,B,et="This flexibility ensures that developers can choose the model and service most suitable for their specific use cases, and allows for easy experimentation.",Ae,Q,tt="Now that we understood why and when to use smolagents, let’s dive deeper into this powerful library!",be,V,Pe,X,nt='<li><a href="https://huggingface.co/blog/smolagents" rel="nofollow">smolagents Blog</a> - Introduction to smolagents and code interactions</li>',Se,Z,Ie,te,ke;return g=new C({props:{title:"Why use smolagents",local:"why-use-smolagents",headingTag:"h1"}}),_=new C({props:{title:"What is smolagents ?",local:"what-is-smolagents-",headingTag:"h2"}}),b=new C({props:{title:"Key Advantages of smolagents",local:"key-advantages-of-smolagents",headingTag:"h3"}}),S=new C({props:{title:"When to use smolagents?",local:"when-to-use-smolagents",headingTag:"h3"}}),z=new C({props:{title:"Code vs. JSON Actions",local:"code-vs-json-actions",headingTag:"h3"}}),U=new C({props:{title:"Agent Types in smolagents",local:"agent-types-in-smolagents",headingTag:"h3"}}),T=new ut({props:{$$slots:{default:[ht]},$$scope:{ctx:ne}}}),D=new C({props:{title:"Model Integration in smolagents",local:"model-integration-in-smolagents",headingTag:"h3"}}),V=new C({props:{title:"Resources",local:"resources",headingTag:"h2"}}),Z=new ct({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/unit2/smolagents/why_use_smolagents.mdx"}}),{c(){f=i("meta"),p=l(),M=i("p"),x=l(),m=i("p"),m.innerHTML=ee,L=l(),c(g.$$.fragment),u=l(),y=i("p"),y.innerHTML=Ee,se=l(),c(_.$$.fragment),le=l(),H=i("p"),H.innerHTML=We,oe=l(),A=i("p"),A.innerHTML=je,ie=l(),c(b.$$.fragment),ae=l(),P=i("ul"),P.innerHTML=Ne,re=l(),c(S.$$.fragment),ge=l(),I=i("p"),I.textContent=Ue,me=l(),k=i("p"),k.textContent=Fe,fe=l(),O=i("ul"),O.innerHTML=Je,pe=l(),c(z.$$.fragment),ue=l(),E=i("p"),E.innerHTML=qe,ce=l(),W=i("p"),W.textContent=Re,he=l(),j=i("p"),j.innerHTML=Ye,de=l(),N=i("p"),N.innerHTML=De,we=l(),c(U.$$.fragment),ve=l(),F=i("p"),F.innerHTML=Ge,$e=l(),J=i("p"),J.innerHTML=Ke,xe=l(),q=i("ul"),q.innerHTML=Be,Le=l(),R=i("p"),R.innerHTML=Qe,Me=l(),Y=i("p"),Y.textContent=Ve,Te=l(),c(T.$$.fragment),Ce=l(),c(D.$$.fragment),ye=l(),G=i("p"),G.innerHTML=Xe,_e=l(),K=i("ul"),K.innerHTML=Ze,He=l(),B=i("p"),B.textContent=et,Ae=l(),Q=i("p"),Q.textContent=tt,be=l(),c(V.$$.fragment),Pe=l(),X=i("ul"),X.innerHTML=nt,Se=l(),c(Z.$$.fragment),Ie=l(),te=i("p"),this.h()},l(e){const t=ft("svelte-u9bgzb",document.head);f=a(t,"META",{name:!0,content:!0}),t.forEach(n),p=o(e),M=a(e,"P",{}),lt(M).forEach(n),x=o(e),m=a(e,"P",{"data-svelte-h":!0}),r(m)!=="svelte-y6hm8g"&&(m.innerHTML=ee),L=o(e),h(g.$$.fragment,e),u=o(e),y=a(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-1jmwdeg"&&(y.innerHTML=Ee),se=o(e),h(_.$$.fragment,e),le=o(e),H=a(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-1r6rx5a"&&(H.innerHTML=We),oe=o(e),A=a(e,"P",{"data-svelte-h":!0}),r(A)!=="svelte-4bzfee"&&(A.innerHTML=je),ie=o(e),h(b.$$.fragment,e),ae=o(e),P=a(e,"UL",{"data-svelte-h":!0}),r(P)!=="svelte-y43olw"&&(P.innerHTML=Ne),re=o(e),h(S.$$.fragment,e),ge=o(e),I=a(e,"P",{"data-svelte-h":!0}),r(I)!=="svelte-8assml"&&(I.textContent=Ue),me=o(e),k=a(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-1l86rc"&&(k.textContent=Fe),fe=o(e),O=a(e,"UL",{"data-svelte-h":!0}),r(O)!=="svelte-1w8dnkn"&&(O.innerHTML=Je),pe=o(e),h(z.$$.fragment,e),ue=o(e),E=a(e,"P",{"data-svelte-h":!0}),r(E)!=="svelte-77j4qm"&&(E.innerHTML=qe),ce=o(e),W=a(e,"P",{"data-svelte-h":!0}),r(W)!=="svelte-w2ds6s"&&(W.textContent=Re),he=o(e),j=a(e,"P",{"data-svelte-h":!0}),r(j)!=="svelte-igz6j7"&&(j.innerHTML=Ye),de=o(e),N=a(e,"P",{"data-svelte-h":!0}),r(N)!=="svelte-d6mlin"&&(N.innerHTML=De),we=o(e),h(U.$$.fragment,e),ve=o(e),F=a(e,"P",{"data-svelte-h":!0}),r(F)!=="svelte-1ewhkz2"&&(F.innerHTML=Ge),$e=o(e),J=a(e,"P",{"data-svelte-h":!0}),r(J)!=="svelte-v3gwmh"&&(J.innerHTML=Ke),xe=o(e),q=a(e,"UL",{"data-svelte-h":!0}),r(q)!=="svelte-86yvzc"&&(q.innerHTML=Be),Le=o(e),R=a(e,"P",{"data-svelte-h":!0}),r(R)!=="svelte-2mo6e2"&&(R.innerHTML=Qe),Me=o(e),Y=a(e,"P",{"data-svelte-h":!0}),r(Y)!=="svelte-7g58wd"&&(Y.textContent=Ve),Te=o(e),h(T.$$.fragment,e),Ce=o(e),h(D.$$.fragment,e),ye=o(e),G=a(e,"P",{"data-svelte-h":!0}),r(G)!=="svelte-1yzbre3"&&(G.innerHTML=Xe),_e=o(e),K=a(e,"UL",{"data-svelte-h":!0}),r(K)!=="svelte-qt4s8x"&&(K.innerHTML=Ze),He=o(e),B=a(e,"P",{"data-svelte-h":!0}),r(B)!=="svelte-345dyo"&&(B.textContent=et),Ae=o(e),Q=a(e,"P",{"data-svelte-h":!0}),r(Q)!=="svelte-o7yv8k"&&(Q.textContent=tt),be=o(e),h(V.$$.fragment,e),Pe=o(e),X=a(e,"UL",{"data-svelte-h":!0}),r(X)!=="svelte-1nmm1j7"&&(X.innerHTML=nt),Se=o(e),h(Z.$$.fragment,e),Ie=o(e),te=a(e,"P",{}),lt(te).forEach(n),this.h()},h(){ot(f,"name","hf:doc:metadata"),ot(f,"content",wt)},m(e,t){pt(document.head,f),s(e,p,t),s(e,M,t),s(e,x,t),s(e,m,t),s(e,L,t),d(g,e,t),s(e,u,t),s(e,y,t),s(e,se,t),d(_,e,t),s(e,le,t),s(e,H,t),s(e,oe,t),s(e,A,t),s(e,ie,t),d(b,e,t),s(e,ae,t),s(e,P,t),s(e,re,t),d(S,e,t),s(e,ge,t),s(e,I,t),s(e,me,t),s(e,k,t),s(e,fe,t),s(e,O,t),s(e,pe,t),d(z,e,t),s(e,ue,t),s(e,E,t),s(e,ce,t),s(e,W,t),s(e,he,t),s(e,j,t),s(e,de,t),s(e,N,t),s(e,we,t),d(U,e,t),s(e,ve,t),s(e,F,t),s(e,$e,t),s(e,J,t),s(e,xe,t),s(e,q,t),s(e,Le,t),s(e,R,t),s(e,Me,t),s(e,Y,t),s(e,Te,t),d(T,e,t),s(e,Ce,t),d(D,e,t),s(e,ye,t),s(e,G,t),s(e,_e,t),s(e,K,t),s(e,He,t),s(e,B,t),s(e,Ae,t),s(e,Q,t),s(e,be,t),d(V,e,t),s(e,Pe,t),s(e,X,t),s(e,Se,t),d(Z,e,t),s(e,Ie,t),s(e,te,t),ke=!0},p(e,[t]){const st={};t&2&&(st.$$scope={dirty:t,ctx:e}),T.$set(st)},i(e){ke||(w(g.$$.fragment,e),w(_.$$.fragment,e),w(b.$$.fragment,e),w(S.$$.fragment,e),w(z.$$.fragment,e),w(U.$$.fragment,e),w(T.$$.fragment,e),w(D.$$.fragment,e),w(V.$$.fragment,e),w(Z.$$.fragment,e),ke=!0)},o(e){v(g.$$.fragment,e),v(_.$$.fragment,e),v(b.$$.fragment,e),v(S.$$.fragment,e),v(z.$$.fragment,e),v(U.$$.fragment,e),v(T.$$.fragment,e),v(D.$$.fragment,e),v(V.$$.fragment,e),v(Z.$$.fragment,e),ke=!1},d(e){e&&(n(p),n(M),n(x),n(m),n(L),n(u),n(y),n(se),n(le),n(H),n(oe),n(A),n(ie),n(ae),n(P),n(re),n(ge),n(I),n(me),n(k),n(fe),n(O),n(pe),n(ue),n(E),n(ce),n(W),n(he),n(j),n(de),n(N),n(we),n(ve),n(F),n($e),n(J),n(xe),n(q),n(Le),n(R),n(Me),n(Y),n(Te),n(Ce),n(ye),n(G),n(_e),n(K),n(He),n(B),n(Ae),n(Q),n(be),n(Pe),n(X),n(Se),n(Ie),n(te)),n(f),$(g,e),$(_,e),$(b,e),$(S,e),$(z,e),$(U,e),$(T,e),$(D,e),$(V,e),$(Z,e)}}}const wt='{"title":"Why use smolagents","local":"why-use-smolagents","sections":[{"title":"What is smolagents ?","local":"what-is-smolagents-","sections":[{"title":"Key Advantages of smolagents","local":"key-advantages-of-smolagents","sections":[],"depth":3},{"title":"When to use smolagents?","local":"when-to-use-smolagents","sections":[],"depth":3},{"title":"Code vs. JSON Actions","local":"code-vs-json-actions","sections":[],"depth":3},{"title":"Agent Types in smolagents","local":"agent-types-in-smolagents","sections":[],"depth":3},{"title":"Model Integration in smolagents","local":"model-integration-in-smolagents","sections":[],"depth":3}],"depth":2},{"title":"Resources","local":"resources","sections":[],"depth":2}],"depth":1}';function vt(ne){return at(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ct extends gt{constructor(f){super(),mt(this,f,vt,dt,it,{})}}export{Ct as component};
