import{s as Gt,f as Ft,n as It,o as St}from"../chunks/scheduler.f6b352c8.js";import{S as Bt,i as Nt,g as s,s as i,r as j,A as Ut,h as a,f as l,c as o,j as qt,u as q,x as g,k as G,y as Kt,a as n,v as F,d as I,t as S,w as B}from"../chunks/index.7f38e934.js";import{H as ct,E as Qt}from"../chunks/EditOnGithub.8311d278.js";function Dt(Lt){let r,N,z,U,u,K,p,$t="我们现在准备好为函数调用微调我们的第一个模型了 🔥。",Q,m,D,v,_t="<p>答案：我们需要<strong>数据</strong></p>",J,b,ht="模型训练可以分为3个步骤：",V,c,Tt='<li><p><strong>模型在大量数据上进行预训练 (pretrained)</strong>。这一步的输出是一个<strong>预训练模型 (pre-trained model)</strong>。例如 <a href="https://huggingface.co/google/gemma-2-2b" rel="nofollow">google/gemma-2-2b</a>。这是一个基础模型，只知道<strong>如何预测下一个词元(token)，而没有良好的指令跟随能力</strong>。</p></li> <li><p>然后，为了在对话环境中发挥作用，模型需要进行<strong>微调 (fine-tuned)</strong>以遵循指令。在这一步中，可以由模型创建者、开源社区、你或任何人进行训练。例如 <a href="https://huggingface.co/google/gemma-2-2b-it" rel="nofollow">google/gemma-2-2b-it</a> 是由 Gemma 项目背后的谷歌团队进行的指令微调模型。</p></li> <li><p>然后可以将模型<strong>对齐 (aligned)</strong>到创建者的偏好。例如，一个必须永远不能对客户无礼的客户服务聊天模型。</p></li>',W,L,xt="通常，像 Gemini 或 Mistral 这样的完整产品<strong>会经历所有这3个步骤</strong>，而你在 Hugging Face 上找到的模型可能已经经过了这些训练步骤中的一个或多个。",X,$,Ct='在本教程中，我们将基于 <a href="https://huggingface.co/google/gemma-2-2b-it" rel="nofollow">google/gemma-2-2b-it</a> 构建一个函数调用模型。基础模型是 <a href="https://huggingface.co/google/gemma-2-2b" rel="nofollow">google/gemma-2-2b</a>，谷歌团队在指令跟随方面对基础模型进行了微调：产生了 <strong>“google/gemma-2-2b-it”</strong>。',Y,_,Mt="在这种情况下，我们将使用 <strong>“google/gemma-2-2b-it”</strong> 作为基础，<strong>而不是基础模型，因为它之前经历的微调对我们的用例很重要</strong>。",Z,h,Ht="由于我们想要通过消息对话与我们的模型进行交互，从基础模型开始<strong>需要更多的训练才能学习指令跟随、聊天和函数调用</strong>。",tt,T,wt="通过从指令微调模型开始，<strong>我们最小化了模型需要学习的信息量</strong>。",et,x,lt,C,dt="LoRA（大语言模型的低秩适应，Low-Rank Adaptation of Large Language Models）是一种流行的轻量级训练技术，它显著<strong>减少了可训练参数的数量</strong>。",nt,M,Pt="它的工作原理是<strong>将较少数量的新权重作为适配器插入到模型中进行训练</strong>。这使得使用 LoRA 进行训练更快、内存效率更高，并产生更小的模型权重（几百 MB），更易于存储和共享。",it,f,yt,ot,H,At="LoRA 通过向 Transformer 层添加秩分解矩阵对来工作，通常关注线性层。在训练期间，我们将”冻结”模型的其余部分，只更新那些新添加的适配器的权重。",st,w,Rt="通过这样做，我们需要训练的参数数量大大减少，因为我们只需要更新适配器的权重。",at,d,kt="在推理过程中，输入通过适配器传递，基础模型或这些适配器权重可以与基础模型合并，不会产生额外的延迟开销。",gt,P,Et="LoRA 特别适用于将<strong>大型</strong>语言模型适应特定任务或领域，同时保持资源需求可控。这有助于减少训练模型所需的内存。",rt,y,zt='如果你想了解更多关于 LoRA 如何工作的信息，你应该查看这个<a href="https://huggingface.co/learn/nlp-course/chapter11/4?fw=pt" rel="nofollow">教程</a>。',ft,A,ut,R,Ot='你可以在这里访问教程笔记本 👉 <a href="https://huggingface.co/agents-course/notebooks/blob/main/bonus-unit1/bonus-unit1.ipynb" rel="nofollow">点击这里</a>。',pt,k,jt='然后，点击  <a href="https://colab.research.google.com/#fileId=https://huggingface.co/agents-course/notebooks/blob/main/bonus-unit1/bonus-unit1.ipynb" rel="nofollow"><img src="https://colab.research.google.com/assets/colab-badge.svg" alt="Open In Colab"/></a> 以便在 Colab Notebook 中运行它。',mt,E,vt,O,bt;return u=new ct({props:{title:"让我们为函数调用微调模型 (Let’s Fine-Tune your model for function-calling)",local:"让我们为函数调用微调模型-lets-fine-tune-your-model-for-function-calling",headingTag:"h1"}}),m=new ct({props:{title:"我们如何训练模型进行函数调用？",local:"我们如何训练模型进行函数调用",headingTag:"h2"}}),x=new ct({props:{title:"LoRA（大语言模型的低秩适应）",local:"lora大语言模型的低秩适应",headingTag:"h2"}}),A=new ct({props:{title:"为函数调用微调模型",local:"为函数调用微调模型",headingTag:"h2"}}),E=new Qt({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/zh-CN/bonus-unit1/fine-tuning.mdx"}}),{c(){r=s("meta"),N=i(),z=s("p"),U=i(),j(u.$$.fragment),K=i(),p=s("p"),p.textContent=$t,Q=i(),j(m.$$.fragment),D=i(),v=s("blockquote"),v.innerHTML=_t,J=i(),b=s("p"),b.textContent=ht,V=i(),c=s("ol"),c.innerHTML=Tt,W=i(),L=s("p"),L.innerHTML=xt,X=i(),$=s("p"),$.innerHTML=Ct,Y=i(),_=s("p"),_.innerHTML=Mt,Z=i(),h=s("p"),h.innerHTML=Ht,tt=i(),T=s("p"),T.innerHTML=wt,et=i(),j(x.$$.fragment),lt=i(),C=s("p"),C.innerHTML=dt,nt=i(),M=s("p"),M.innerHTML=Pt,it=i(),f=s("img"),ot=i(),H=s("p"),H.textContent=At,st=i(),w=s("p"),w.textContent=Rt,at=i(),d=s("p"),d.textContent=kt,gt=i(),P=s("p"),P.innerHTML=Et,rt=i(),y=s("p"),y.innerHTML=zt,ft=i(),j(A.$$.fragment),ut=i(),R=s("p"),R.innerHTML=Ot,pt=i(),k=s("p"),k.innerHTML=jt,mt=i(),j(E.$$.fragment),vt=i(),O=s("p"),this.h()},l(t){const e=Ut("svelte-u9bgzb",document.head);r=a(e,"META",{name:!0,content:!0}),e.forEach(l),N=o(t),z=a(t,"P",{}),qt(z).forEach(l),U=o(t),q(u.$$.fragment,t),K=o(t),p=a(t,"P",{"data-svelte-h":!0}),g(p)!=="svelte-1u1c6j3"&&(p.textContent=$t),Q=o(t),q(m.$$.fragment,t),D=o(t),v=a(t,"BLOCKQUOTE",{"data-svelte-h":!0}),g(v)!=="svelte-1t11vy0"&&(v.innerHTML=_t),J=o(t),b=a(t,"P",{"data-svelte-h":!0}),g(b)!=="svelte-1wo4rc6"&&(b.textContent=ht),V=o(t),c=a(t,"OL",{"data-svelte-h":!0}),g(c)!=="svelte-b9dimo"&&(c.innerHTML=Tt),W=o(t),L=a(t,"P",{"data-svelte-h":!0}),g(L)!=="svelte-1yywgjf"&&(L.innerHTML=xt),X=o(t),$=a(t,"P",{"data-svelte-h":!0}),g($)!=="svelte-1jd7z2f"&&($.innerHTML=Ct),Y=o(t),_=a(t,"P",{"data-svelte-h":!0}),g(_)!=="svelte-urz94n"&&(_.innerHTML=Mt),Z=o(t),h=a(t,"P",{"data-svelte-h":!0}),g(h)!=="svelte-1dad4ks"&&(h.innerHTML=Ht),tt=o(t),T=a(t,"P",{"data-svelte-h":!0}),g(T)!=="svelte-1a74fep"&&(T.innerHTML=wt),et=o(t),q(x.$$.fragment,t),lt=o(t),C=a(t,"P",{"data-svelte-h":!0}),g(C)!=="svelte-cau34y"&&(C.innerHTML=dt),nt=o(t),M=a(t,"P",{"data-svelte-h":!0}),g(M)!=="svelte-mprdad"&&(M.innerHTML=Pt),it=o(t),f=a(t,"IMG",{src:!0,alt:!0,width:!0}),ot=o(t),H=a(t,"P",{"data-svelte-h":!0}),g(H)!=="svelte-132b4nl"&&(H.textContent=At),st=o(t),w=a(t,"P",{"data-svelte-h":!0}),g(w)!=="svelte-2c9647"&&(w.textContent=Rt),at=o(t),d=a(t,"P",{"data-svelte-h":!0}),g(d)!=="svelte-huy21"&&(d.textContent=kt),gt=o(t),P=a(t,"P",{"data-svelte-h":!0}),g(P)!=="svelte-i6bzu8"&&(P.innerHTML=Et),rt=o(t),y=a(t,"P",{"data-svelte-h":!0}),g(y)!=="svelte-4g9gid"&&(y.innerHTML=zt),ft=o(t),q(A.$$.fragment,t),ut=o(t),R=a(t,"P",{"data-svelte-h":!0}),g(R)!=="svelte-150lnpv"&&(R.innerHTML=Ot),pt=o(t),k=a(t,"P",{"data-svelte-h":!0}),g(k)!=="svelte-1626mlc"&&(k.innerHTML=jt),mt=o(t),q(E.$$.fragment,t),vt=o(t),O=a(t,"P",{}),qt(O).forEach(l),this.h()},h(){G(r,"name","hf:doc:metadata"),G(r,"content",Jt),Ft(f.src,yt="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/blog_multi-lora-serving_LoRA.gif")||G(f,"src",yt),G(f,"alt","LoRA inference"),G(f,"width","50%")},m(t,e){Kt(document.head,r),n(t,N,e),n(t,z,e),n(t,U,e),F(u,t,e),n(t,K,e),n(t,p,e),n(t,Q,e),F(m,t,e),n(t,D,e),n(t,v,e),n(t,J,e),n(t,b,e),n(t,V,e),n(t,c,e),n(t,W,e),n(t,L,e),n(t,X,e),n(t,$,e),n(t,Y,e),n(t,_,e),n(t,Z,e),n(t,h,e),n(t,tt,e),n(t,T,e),n(t,et,e),F(x,t,e),n(t,lt,e),n(t,C,e),n(t,nt,e),n(t,M,e),n(t,it,e),n(t,f,e),n(t,ot,e),n(t,H,e),n(t,st,e),n(t,w,e),n(t,at,e),n(t,d,e),n(t,gt,e),n(t,P,e),n(t,rt,e),n(t,y,e),n(t,ft,e),F(A,t,e),n(t,ut,e),n(t,R,e),n(t,pt,e),n(t,k,e),n(t,mt,e),F(E,t,e),n(t,vt,e),n(t,O,e),bt=!0},p:It,i(t){bt||(I(u.$$.fragment,t),I(m.$$.fragment,t),I(x.$$.fragment,t),I(A.$$.fragment,t),I(E.$$.fragment,t),bt=!0)},o(t){S(u.$$.fragment,t),S(m.$$.fragment,t),S(x.$$.fragment,t),S(A.$$.fragment,t),S(E.$$.fragment,t),bt=!1},d(t){t&&(l(N),l(z),l(U),l(K),l(p),l(Q),l(D),l(v),l(J),l(b),l(V),l(c),l(W),l(L),l(X),l($),l(Y),l(_),l(Z),l(h),l(tt),l(T),l(et),l(lt),l(C),l(nt),l(M),l(it),l(f),l(ot),l(H),l(st),l(w),l(at),l(d),l(gt),l(P),l(rt),l(y),l(ft),l(ut),l(R),l(pt),l(k),l(mt),l(vt),l(O)),l(r),B(u,t),B(m,t),B(x,t),B(A,t),B(E,t)}}}const Jt='{"title":"让我们为函数调用微调模型 (Let’s Fine-Tune your model for function-calling)","local":"让我们为函数调用微调模型-lets-fine-tune-your-model-for-function-calling","sections":[{"title":"我们如何训练模型进行函数调用？","local":"我们如何训练模型进行函数调用","sections":[],"depth":2},{"title":"LoRA（大语言模型的低秩适应）","local":"lora大语言模型的低秩适应","sections":[],"depth":2},{"title":"为函数调用微调模型","local":"为函数调用微调模型","sections":[],"depth":2}],"depth":1}';function Vt(Lt){return St(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Zt extends Bt{constructor(r){super(),Nt(this,r,Vt,Dt,Gt,{})}}export{Zt as component};
